/* ***********************************************************************  
  FREE IP GENERAL PUBLIC LICENSE
  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION

  1.  You may copy and distribute verbatim copies of this core, as long
      as this file, and the other associated files, remain intact and
      unmodified.  Modifications are outlined below.  
  2.  You may use this core in any way, be it academic, commercial, or
      military.  Modified or not.  
  3.  Distribution of this file must be free of charge.  Charging is
      allowed only for value added services.  Value added services
      would include copying fees, modifications, customizations, and
      inclusion in other products.
  4.  If a modified source code is distributed, the original unmodified
      source code must also be included (or a link to my web
      site).  In the modified source code there must be clear
      identification of the modified version.
  5.  Visit the my web site for additional information.
      http://www.iosifk.narod.ru

*********************************************************************** */ 

////////////////////////////////////////////////////////////////////////
//	Name File		  : CableTAP.cpp   					    											//
//	Autor					: Iosif Karshenboim																	//
//	      				: www.iosifk.narod.ru																//
//	Description		: JTAG soft tool                    								//
//	Start design	: 23.08.2006																				//
//	Last revision	: 23.08.2006																				//
////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
// CableTAP.cpp:      .
//-----------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>

#pragma hdrstop
#include "MyParPort.h"
#include "MyCable.h"
#include "CableTAP.h"
#include "Unit1.h"

//---------------------------------------------------------------------------

CableTAP::CableTAP()
{
//  
 Cable = new MyCable();

}
//---------------------------------------------------------------------------

CableTAP::~CableTAP()
{
 //  
 delete Cable;
}
//---------------------------------------------------------------------------
void CableTAP::CableTAPSetParams(String strNewName,
                          char tdo, char trst, char tms, char tck,
                          char tdi, char srst, char o_inv, char i_inv,
                          char init, char vcc_sense, char prog,
													char ctrl, char d6, char busy, char pe)

{ // 
  Cable->MyCableSetParams(strNewName, tdo, trst, tms, tck, tdi, srst, o_inv,
                           i_inv, init, vcc_sense, prog, ctrl, d6, busy, pe);
}
//---------------------------------------------------------------------------
bool CableTAP::CableTAPInit(char init, char tdo, char trst, char tms, char tdi,
                            char srst, char tck, char prog, char ctrl)
{
 bool bOK=true;
	// 
  //   
 Cable->SetTRST(trst);
 Cable->SetTMS (tms);
 Cable->SetTCK (tck);
 Cable->SetTDI (tdi);
 Cable->SetSRST(srst);

 Cable->SetPROG(prog);
 Cable->SetCTRL(ctrl);

 Cable->SetPortDataInit(tdo, trst, tms, tck, tdi, srst, init, prog, ctrl); 

  bool cTmp1 = Cable->CheckPower();
  bool cTmp2 = Cable->CheckHW();

  if(!(cTmp1 && cTmp2))        //     
   bOK = false;
  return (bOK);

}
//---------------------------------------------------------------------------
String CableTAP::ShowCableTAPName(void)
{
 String strTmp = Cable->ShowMyCableName(); return(strTmp);
}
//---------------------------------------------------------------------------
char CableTAP::ShowCableTAPTDO_MASK(void)
{
 char cTmp = Cable->ShowMyCableTDO_MASK();  return(cTmp);
}
//---------------------------------------------------------------------------
char CableTAP::ShowCableTAPTRST_MASK(void)
{
 char cTmp = Cable->ShowMyCableTRST_MASK();  return(cTmp);
}
//---------------------------------------------------------------------------
char CableTAP::ShowCableTAPTMS_MASK(void)
{
 char cTmp = Cable->ShowMyCableTMS_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char CableTAP::ShowCableTAPTCK_MASK(void)
{
 char cTmp = Cable->ShowMyCableTCK_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char CableTAP::ShowCableTAPTDI_MASK(void)
{
 char cTmp = Cable->ShowMyCableTDI_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char CableTAP::ShowCableTAPSRST_MASK(void)
{
 char cTmp = Cable->ShowMyCableSRST_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char CableTAP::ShowCableTAPOUTPUT_INVERT(void)
{
 char cTmp = Cable->ShowMyCableOUTPUT_INVERT();  return(cTmp);
}
//---------------------------------------------------------------------------
char CableTAP::ShowCableTAPINPUT_INVERT(void)
{
 char cTmp = Cable->ShowMyCableINPUT_INVERT(); return(cTmp);
}
//---------------------------------------------------------------------------
char CableTAP::ShowCableTAPPORT_INIT(void)
{
 char cTmp = Cable->ShowMyCablePORT_INIT(); return(cTmp);
}
//---------------------------------------------------------------------------
char CableTAP::ShowCableTAPVCC_SENSE(void)
{
 char cTmp = Cable->ShowMyCableVCC_SENSE(); return(cTmp);
}
//---------------------------------------------------------------------------
char CableTAP::ShowCableTAPPROG_MASK(void)
{
 char cTmp = Cable->ShowMyCablePROG_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char CableTAP::ShowCableTAPCTRL_MASK(void)
{
 char cTmp = Cable->ShowMyCableCTRL_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char CableTAP::ShowCableTAPD6_MASK(void)
{
 char cTmp = Cable->ShowMyCableD6_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char CableTAP::ShowCableTAPBUSY_MASK(void)
{
 char cTmp = Cable->ShowMyCableBUSY_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char CableTAP::ShowCableTAPPE_MASK(void)
{
 char cTmp = Cable->ShowMyCablePE_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
 String CableTAP::ShowCableTAP_AllParams(void)
{
 String strTmp =
 "cable->name - "            + Cable->ShowMyCableName() + "\n" +
 "cable->TDO_MASK      - 0x" + IntToHex(0xFF&(Cable->ShowMyCableTDO_MASK()), 2     ) + "\n" + 
 "cable->TRST_MASK     - 0x" + IntToHex(0xFF&(Cable->ShowMyCableTRST_MASK()), 2    ) + "\n" + 
 "cable->TMS_MASK      - 0x" + IntToHex(0xFF&(Cable->ShowMyCableTMS_MASK()), 2     ) + "\n" + 
 "cable->TCK_MASK      - 0x" + IntToHex(0xFF&(Cable->ShowMyCableTCK_MASK()), 2     ) + "\n" +
 "cable->TDI_MASK      - 0x" + IntToHex(0xFF&(Cable->ShowMyCableTDI_MASK()), 2     ) + "\n" +
 "cable->SRST_MASK     - 0x" + IntToHex(0xFF&(Cable->ShowMyCableSRST_MASK()), 2    ) + "\n" +
 "cable->OUTPUT_INVERT - 0x" + IntToHex(0xFF&(Cable->ShowMyCableOUTPUT_INVERT()), 2) + "\n" +
 "cable->INPUT_INVERT  - 0x" + IntToHex(0xFF&(Cable->ShowMyCableINPUT_INVERT()), 2 ) + "\n" +
 "cable->PORT_INIT     - 0x" + IntToHex(0xFF&(Cable->ShowMyCablePORT_INIT()), 2    ) + "\n" +

 "cable->VCC_SENSE     - 0x" + IntToHex(0xFF&(Cable->ShowMyCableVCC_SENSE()), 2    ) + "\n" +
 "cable->PROG_MASK     - 0x" + IntToHex(0xFF&(Cable->ShowMyCablePROG_MASK()), 2    ) + "\n" +
 "cable->CTRL_MASK     - 0x" + IntToHex(0xFF&(Cable->ShowMyCableCTRL_MASK()), 2    ) + "\n" +
 "cable->D6_MASK       - 0x" + IntToHex(0xFF&(Cable->ShowMyCableD6_MASK()), 2      ) + "\n" +
 "cable->BUSY_MASK     - 0x" + IntToHex(0xFF&(Cable->ShowMyCableBUSY_MASK()), 2    ) + "\n" +
 "cable->PE_MASK       - 0x" + IntToHex(0xFF&(Cable->ShowMyCablePE_MASK()), 2      ) + "\n";

 return(strTmp);
}
//---------------------------------------------------------------------------
 char CableTAP::GetTdoData(void)
{
 char cTmp = Cable->GetTdoData(); return(cTmp);
}
//---------------------------------------------------------------------------
 bool CableTAP::CheckPower(void)
{
 bool cTmp = Cable->CheckPower(); return(cTmp);
}
//---------------------------------------------------------------------------
 bool CableTAP::CheckHW(void)
{
 bool cTmp = Cable->CheckHW(); return(cTmp);
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
char CableTAP::ShowDataportValue(void)
{
 char cTmp = Cable->ShowDataportValue(); return(cTmp);
}
//---------------------------------------------------------------------------
char CableTAP::GetDataportValue(void)
{
 char cTmp = Cable->GetPortData(); return(cTmp);
}

//---------------------------------------------------------------------------
//  tms  tdi   N - ,  
//---------------------------------------------------------------------------

void CableTAP::WriteTMS_SetTDI(char tms, char tdi, char N, String strComment, bool bMonitor)
{
 	char tms_scan = tms;
 	char tdi_scan = tdi;
 
 for (int i=0; i<N; i++)
 {
//  int Tmp1 = ((tdi >> i) & 1);
//  int Tmp2 = ((tms >> i) & 1);
//  Cable->_WriteBitCmd(Tmp1, Tmp2, strComment, true /*, TRichEdit *pRichEdit*/);
  Cable->_WriteBitCmd(tdi_scan & 1, tms_scan & 1, strComment, bMonitor /*, TRichEdit *pRichEdit*/);
 	tms_scan = tms_scan >> 1;
 	tdi_scan = tdi_scan >> 1;
  }
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//  tms  tdi   
//     
// N - ,  
//---------------------------------------------------------------------------

String CableTAP::RdWriteTMS_SetTDI(char tms, char tdi, char N, String strComment, bool bMonitor)
{
 	char tms_scan = tms;
 	char tdi_scan = tdi;
	String strScanIn = "";
  String strTmp = "";
 for (char i=0; i<N; i++)
 {
//  int Tmp1 = ((tdi >> i) & 1);
//  int Tmp2 = ((tms >> i) & 1);



 // strTmp = Cable->RWriteBitCmd(Tmp1, Tmp2, strComment, true /*, TRichEdit *pRichEdit*/);
  strTmp = Cable->RWriteBitCmd(tdi_scan & 1, tms_scan & 1, strComment, bMonitor /*, TRichEdit *pRichEdit*/);


	//    
  strScanIn = strTmp + strScanIn;

 	tms_scan = tms_scan >> 1;
 	tdi_scan = tdi_scan >> 1;
  }

	return (strScanIn);
}
//---------------------------------------------------------------------------
 String CableTAP::RdLastTDI(void)
{
   //    !!!
   Cable->SetTCK (0);
  	//    
	String strScanIn = IntToStr(Cable->GetTdoData() & 1) + strScanIn;

	return (strScanIn);
}
//---------------------------------------------------------------------------





