/* ***********************************************************************  
  FREE IP GENERAL PUBLIC LICENSE
  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION

  1.  You may copy and distribute verbatim copies of this core, as long
      as this file, and the other associated files, remain intact and
      unmodified.  Modifications are outlined below.  
  2.  You may use this core in any way, be it academic, commercial, or
      military.  Modified or not.  
  3.  Distribution of this file must be free of charge.  Charging is
      allowed only for value added services.  Value added services
      would include copying fees, modifications, customizations, and
      inclusion in other products.
  4.  If a modified source code is distributed, the original unmodified
      source code must also be included (or a link to my web
      site).  In the modified source code there must be clear
      identification of the modified version.
  5.  Visit the my web site for additional information.
      http://www.iosifk.narod.ru

*********************************************************************** */ 

////////////////////////////////////////////////////////////////////////
//	Name File		  : CableTAP.h    					    											//
//	Autor					: Iosif Karshenboim																	//
//	      				: www.iosifk.narod.ru																//
//	Description		: JTAG soft tool                    								//
//	Start design	: 23.08.2006																				//
//	Last revision	: 23.08.2006																				//
////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
// CableTAP.h: contain headers of CableTAP functions.
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
#ifndef CableTAP_h
#define CableTAP_h
//-----------------------------------------------------------------------------
MyCable* Cable; // pointer to instance of MyCable class to get access to ParPort

class CableTAP {

 // ,   
 MyCable;
 
public:

  CableTAP();
  ~CableTAP();


 //   
 void CableTAP::CableTAPSetParams(String strNewName,
                          char tdo, char trst, char tms, char tck,
                          char tdi, char srst, char o_inv, char i_inv,
                          char init, char vcc_sense, char prog,
													char ctrl, char d6, char busy, char pe);


 //  
  bool CableTAP::CableTAPInit(char init, char tdo, char trst, char tms, char tdi, 
                              char srst, char tck, char prog, char ctrl);


 //   
 void CableTAP::SetTRST(char trst)			{Cable->SetTRST(trst);};
 void CableTAP::SetTMS (char tms)				{Cable->SetTMS (tms);};
 void CableTAP::SetTCK (char tck)				{Cable->SetTCK (tck);};
 void CableTAP::SetTDI (char tdi)				{Cable->SetTDI (tdi);};
 void CableTAP::SetSRST(char srst)			{Cable->SetSRST(srst);};
 //--  
//        !!!!
 void CableTAP::SetPROG (char prog)			{Cable->SetPROG (prog);};
 void CableTAP::SetCTRL(char ctrl)			{Cable->SetCTRL(ctrl);};


 //    
// String CableTAP::ShowCableTAPName(void)				 {return(Cable->ShowMyCableName());};
 String CableTAP::ShowCableTAPName(void);
 
 char CableTAP::ShowCableTAPTDO_MASK(void);       
 char CableTAP::ShowCableTAPTRST_MASK(void);      
 char CableTAP::ShowCableTAPTMS_MASK(void);       
 char CableTAP::ShowCableTAPTCK_MASK(void);       
 char CableTAP::ShowCableTAPTDI_MASK(void);       
 char CableTAP::ShowCableTAPSRST_MASK(void);      
 char CableTAP::ShowCableTAPOUTPUT_INVERT(void);  
 char CableTAP::ShowCableTAPINPUT_INVERT(void);
 char CableTAP::ShowCableTAPPORT_INIT(void);

  //--  
char CableTAP::ShowCableTAPVCC_SENSE(void);
 char CableTAP::ShowCableTAPPROG_MASK(void);
 char CableTAP::ShowCableTAPCTRL_MASK(void);
 char CableTAP::ShowCableTAPD6_MASK(void);  
 char CableTAP::ShowCableTAPBUSY_MASK(void);
 char CableTAP::ShowCableTAPPE_MASK(void);
 //   
 char CableTAP::GetTdoData(void);
 bool CableTAP::CheckPower(void);
 bool CableTAP::CheckHW(void);


 String CableTAP::ShowCableTAP_AllParams(void);

 char CableTAP::ShowDataportValue(void);  
 char CableTAP::GetDataportValue(void);   
 
 void CableTAP::UpdatePortDataCLK(void)  {Cable->UpdatePortDataCLK();};

 void CableTAP::WriteTMS_SetTDI(char tms, char tdi, char N, String strComment, bool bMonitor);
 String CableTAP::RdWriteTMS_SetTDI(char tms, char tdi, char N, String strComment, bool bMonitor);
 String CableTAP::RdLastTDI(void);

};
//-----------------------------------------------------------------------------
#endif
