/* ***********************************************************************  
  FREE IP GENERAL PUBLIC LICENSE
  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION

  1.  You may copy and distribute verbatim copies of this core, as long
      as this file, and the other associated files, remain intact and
      unmodified.  Modifications are outlined below.  
  2.  You may use this core in any way, be it academic, commercial, or
      military.  Modified or not.  
  3.  Distribution of this file must be free of charge.  Charging is
      allowed only for value added services.  Value added services
      would include copying fees, modifications, customizations, and
      inclusion in other products.
  4.  If a modified source code is distributed, the original unmodified
      source code must also be included (or a link to my web
      site).  In the modified source code there must be clear
      identification of the modified version.
  5.  Visit the my web site for additional information.
      http://www.iosifk.narod.ru

*********************************************************************** */ 

////////////////////////////////////////////////////////////////////////
//	Name File		  : MyCable.cpp   					    											//
//	Autor					: Iosif Karshenboim																	//
//	      				: www.iosifk.narod.ru																//
//	Description		: JTAG soft tool                    								//
//	Start design	: 23.08.2006																				//
//	Last revision	: 23.08.2006																				//
////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
// MyCable.cpp:      .
//-----------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>

#pragma hdrstop
#include "MyParPort.h"
#include "MyCable.h"

#include "Unit1.h"

MyParPort* PPort; // pointer to instance of MyParPort class to get access to ParPort


//---------------------------------------------------------------------------

MyCable::MyCable() 
{
//  
 PPort = new MyParPort();
 dataport_value = PORT_INIT;
}
//---------------------------------------------------------------------------

MyCable::~MyCable()
{
 //  
 delete PPort;
}
//---------------------------------------------------------------------------
void MyCable::MyCableSetParams(String strNewName,
                          char ctdo, char ctrst, char ctms, char ctck,
                          char ctdi, char csrst, char co_inv, char ci_inv,
                          char cinit, char cvcc_sense, char cprog,
													char cctrl, char cd6, char cbusy, char cpe)


{ // 
  strName = strNewName;
	TDO_MASK = ctdo;				/* status port bit containing current TDO value */
	TRST_MASK = ctrst;			/* data port bit for TRST */
	TMS_MASK = ctms;				/* data port bit for TMS */
	TCK_MASK = ctck;				/* data port bit for TCK */
	TDI_MASK = ctdi;				/* data port bit for TDI */
	SRST_MASK = csrst;			/* data port bit for SRST */
	OUTPUT_INVERT = co_inv;/* data port bits that should be inverted */
	INPUT_INVERT = ci_inv;	/* status port that should be inverted */
	PORT_INIT = cinit;			/* initialize data port with this value */

  VCC_SENSE = cvcc_sense;
  PROG_MASK = cprog;
  CTRL_MASK = cctrl;
  D6_MASK = cd6;
  BUSY_MASK = cbusy;
  PE_MASK = cpe;
}
//---------------------------------------------------------------------------
String MyCable::_WriteBitCmd(char cTDI, char cTMS, String strComment, bool bMonitor/*, TRichEdit *pRichEdit*/)
{
  BYTE   DataBit  = dataport_value;
    
		if(cTDI  == 1)
		  DataBit = DataBit | TDI_MASK;
      
    //------------
     if(cTMS == 1)
  	  DataBit =  DataBit | TMS_MASK;

    //------------
   if(bMonitor==true)
      Form1->RichEdit1->Lines->Add("_WriteCmd - " + strComment
                           + ", TDI - " + IntToStr(cTDI)
                           + ", TMS - " + IntToStr(cTMS)
                           + ", DataBit - " + IntToHex(DataBit^OUTPUT_INVERT, 2));  

    PPort->WrData(DataBit ^ OUTPUT_INVERT);
    DataBit = DataBit | TCK_MASK;

			// Pause???

    PPort->WrData(DataBit ^ OUTPUT_INVERT);

 String  strResult = "0";
  return(strResult);
}
//---------------------------------------------------------------------------
String MyCable::RWriteBitCmd(char cTDI, char cTMS, String strComment, bool bMonitor/*, TRichEdit1 *pRichEdit*/)
{
  BYTE   DataBit  = dataport_value;
    
		if(cTDI  == 1)
		  DataBit = DataBit | TDI_MASK;
      
    //------------
     if(cTMS == 1)
  	  DataBit =  DataBit | TMS_MASK;


    PPort->WrData(DataBit ^ OUTPUT_INVERT);

    DataBit = DataBit | TCK_MASK;

			// Pause???

    PPort->WrData(DataBit ^ OUTPUT_INVERT);

    int inNum = (PPort->RdStatus() ^ INPUT_INVERT);        // Status Port, bit "Select In"



  String strTmp;
  if((inNum & TDO_MASK)!=0)
    strTmp = "1";
  else
    strTmp = "0";

    //------------
   if(bMonitor==true)
     Form1->RichEdit1->Lines->Add("WriteCmd - " + strComment
                           + ", TDI - " + IntToStr(cTDI)
                           + ", TMS - " + IntToStr(cTMS)
                           + ", DataBit - " + IntToHex(DataBit^OUTPUT_INVERT, 2)
                           + ", Read TDO - " + strTmp);



  return(strTmp);
}
//---------------------------------------------------------------------------
char MyCable::GetPortData(void)
{
 return (PPort->RdData());
}
//---------------------------------------------------------------------------
char MyCable::SetPortDataInit(char ctdo, char ctrst, char ctms, char ctck,
                          char ctdi, char csrst, char cinit, char cprog,
													char cctrl)

{
 	if (cprog==1)
		dataport_value |= PROG_MASK;
	else
		dataport_value &= ~PROG_MASK;
	
	if (cctrl==1)
		dataport_value |= CTRL_MASK;
	else
		dataport_value &= ~CTRL_MASK;
 
	if (ctrst == 0)
 		dataport_value |= TRST_MASK;
	else 
		dataport_value &= ~TRST_MASK;

 if (ctms==1)
		dataport_value |= TMS_MASK;
	else
		dataport_value &= ~TMS_MASK;

 	if (ctck==1)
		dataport_value |= TCK_MASK;
	else
		dataport_value &= ~TCK_MASK;

	if (ctdi==1)
		dataport_value |= TDI_MASK;
	else
		dataport_value &= ~TDI_MASK;

	if (csrst == 0)
		dataport_value |= SRST_MASK;
	else
		dataport_value &= ~SRST_MASK;

    PPort->WrData(dataport_value ^ OUTPUT_INVERT);

 return (dataport_value);

}

//---------------------------------------------------------------------------
 void MyCable::SetTRST(char trst)
{
	if (trst == 0)
 		dataport_value |= TRST_MASK;
	else 
		dataport_value &= ~TRST_MASK;
}
 //---------------------------------------------------------------------------
 void MyCable::SetTMS (char tms)
{
 if (tms==1)
		dataport_value |= TMS_MASK;
	else
		dataport_value &= ~TMS_MASK;
}
 //---------------------------------------------------------------------------
 void MyCable::SetTCK (char tck)
{
 	if (tck==1)
		dataport_value |= TCK_MASK;
	else
		dataport_value &= ~TCK_MASK;
}
//---------------------------------------------------------------------------
 void MyCable::SetTDI (char tdi)
{
	if (tdi==1)
		dataport_value |= TDI_MASK;
	else
		dataport_value &= ~TDI_MASK;
}
//---------------------------------------------------------------------------
 void MyCable::SetSRST(char srst)
{
	if (srst == 0)
		dataport_value |= SRST_MASK;
	else if (srst == 1)
		dataport_value &= ~SRST_MASK;
}
//---------------------------------------------------------------------------
 void MyCable::SetPROG(char cprog)
{
	if (cprog==1)
		dataport_value |= PROG_MASK;
	else
		dataport_value &= ~PROG_MASK;
}
//---------------------------------------------------------------------------
 void MyCable::SetCTRL (char cctrl)
{
	if (cctrl==1)
		dataport_value |= CTRL_MASK;
	else
		dataport_value &= ~CTRL_MASK;
}
//---------------------------------------------------------------------------
void MyCable::UpdatePortDataCLK(void)
{   //   CLK
    dataport_value &= ~TCK_MASK;                       // CLK=0
    PPort->WrData(dataport_value ^ OUTPUT_INVERT);
 		dataport_value |= TCK_MASK;
    PPort->WrData(dataport_value ^ OUTPUT_INVERT);     // CLK=1
		dataport_value &= ~TCK_MASK;
    PPort->WrData(dataport_value ^ OUTPUT_INVERT);      // CLK=0
}
//---------------------------------------------------------------------------
void MyCable::UpdatePortData(void)
{   //    ,  
    PPort->WrData(dataport_value ^ OUTPUT_INVERT);
}
//---------------------------------------------------------------------------
 //--  

 char MyCable::GetTdoData(void)
{
//	char cTmp = (PPort->RdData() ^ INPUT_INVERT);
// char cTmp3 = (PPort->RdStatus() ^ INPUT_INVERT) & TDO_MASK;
  char cTmp1 = (PPort->RdStatus());
  char cTmp2 = cTmp1 ^ INPUT_INVERT;
  char cTmp3 = cTmp2 & TDO_MASK;
//  char cTmp = (cTmp3 >> TDO_MASK) & 1;
   char cTmp;
  if(cTmp3 != 0)
   cTmp = 1;
  else
   cTmp = 0;

  return (cTmp);
}
//---------------------------------------------------------------------------
 bool MyCable::CheckPower(void)
{
 bool bOK = true;
 dataport_value = PORT_INIT &= ~VCC_SENSE;      //  0  ,  1,
 PPort->WrData(dataport_value ^ OUTPUT_INVERT); //     
                                                //    
 char cTmp = (PPort->RdStatus() ^ INPUT_INVERT) & VCC_SENSE;        //     
 if(cTmp == 0)
  {
   ShowMessage("   DUT!");
   bOK = false;
   }
  return (bOK);
}

//---------------------------------------------------------------------------
 bool MyCable::CheckHW(void)
{
 bool bOK = true;

 //     !!!
 dataport_value = PORT_INIT |= D6_MASK;      //  1  ,
 PPort->WrData(dataport_value ^ OUTPUT_INVERT); //     
                                                //   ,       - INPUT_INVERT,
                                                //    
 char cTmp1 = (PPort->RdStatus() ^ INPUT_INVERT) & BUSY_MASK;
 char cTmp2 = (PPort->RdStatus() ^ INPUT_INVERT) & PE_MASK;

 if((cTmp1 == 0)||(cTmp2 == 0))        //     
  {
   ShowMessage("   !");
   bOK = false;
   }
  return (bOK);
}
//---------------------------------------------------------------------------
