/* ***********************************************************************  
  FREE IP GENERAL PUBLIC LICENSE
  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION

  1.  You may copy and distribute verbatim copies of this core, as long
      as this file, and the other associated files, remain intact and
      unmodified.  Modifications are outlined below.  
  2.  You may use this core in any way, be it academic, commercial, or
      military.  Modified or not.  
  3.  Distribution of this file must be free of charge.  Charging is
      allowed only for value added services.  Value added services
      would include copying fees, modifications, customizations, and
      inclusion in other products.
  4.  If a modified source code is distributed, the original unmodified
      source code must also be included (or a link to my web
      site).  In the modified source code there must be clear
      identification of the modified version.
  5.  Visit the my web site for additional information.
      http://www.iosifk.narod.ru

*********************************************************************** */ 

////////////////////////////////////////////////////////////////////////
//	Name File		  : MyCable.h        				    											//
//	Autor					: Iosif Karshenboim																	//
//	      				: www.iosifk.narod.ru																//
//	Description		: JTAG soft tool                    								//
//	Start design	: 23.08.2006																				//
//	Last revision	: 23.08.2006																				//
////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
// MyCable.h: contain headers of MyCable functions.
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
#ifndef MyCable_h
#define MyCable_h
//-----------------------------------------------------------------------------
  

class MyCable {
    //   	char init[10];
	  //    int count;
  char dataport_value;
  String strLowLewelComment;

 // ,   
  String strName;
	unsigned char TDO_MASK;				// status port bit containing current TDO value   -  
	unsigned char TRST_MASK;			// data port bit for TRST
	unsigned char TMS_MASK;				// data port bit for TMS
	unsigned char TCK_MASK;				// data port bit for TCK
	unsigned char TDI_MASK;				// data port bit for TDI
	unsigned char SRST_MASK;			// data port bit for SRST
	unsigned char OUTPUT_INVERT;	// data port bits that should be inverted
	unsigned char INPUT_INVERT;		// status port that should be inverted
	unsigned char PORT_INIT;			// initialize data port with this value

	unsigned char VCC_SENSE; //  -  
	unsigned char PROG_MASK;
	unsigned char CTRL_MASK;
	unsigned char D6_MASK;
	unsigned char BUSY_MASK;  //  -  
	unsigned char PE_MASK;    //  -  


 
public:

  MyCable();
  ~MyCable();


 //   
void MyCable::MyCableSetParams(String strNewName,
                          char ctdo, char ctrst, char ctms, char ctck,
                          char ctdi, char csrst, char co_inv, char ci_inv,
                          char cinit, char cvcc_sense, char cprog,
													char cctrl, char cd6, char cbusy, char cpe);
 /*
 //   
 void MyCable::MyCableInit(String strNewName,
                          char ctdo, char ctrst, char ctms, char ctck,
                          char ctdi, char csrst, char co_inv, char ci_inv,
                          char cinit);
 */

 //   

 void MyCable::SetTRST(char trst);
 void MyCable::SetTMS (char tms);
 void MyCable::SetTCK (char tck);
 void MyCable::SetTDI (char tdi);
 void MyCable::SetSRST(char srst);

 //--  
 void MyCable::SetPROG(char cprog);
 void MyCable::SetCTRL (char cctrl);

 //    
 String MyCable::ShowMyCableName(void)				 {return(strName);};
 char MyCable::ShowMyCableTDO_MASK(void)       {return(TDO_MASK);};
 char MyCable::ShowMyCableTRST_MASK(void)      {return(TRST_MASK);};
 char MyCable::ShowMyCableTMS_MASK(void)       {return(TMS_MASK);};
 char MyCable::ShowMyCableTCK_MASK(void)       {return(TCK_MASK);};
 char MyCable::ShowMyCableTDI_MASK(void)       {return(TDI_MASK);};
 char MyCable::ShowMyCableSRST_MASK(void)      {return(SRST_MASK);};
 char MyCable::ShowMyCableOUTPUT_INVERT(void)  {return(OUTPUT_INVERT);};
 char MyCable::ShowMyCableINPUT_INVERT(void)   {return(INPUT_INVERT);};
 char MyCable::ShowMyCablePORT_INIT(void)      {return(PORT_INIT);};

 //--  
 char MyCable::ShowMyCableVCC_SENSE(void)      {return(VCC_SENSE);};
 char MyCable::ShowMyCablePROG_MASK(void)      {return(PROG_MASK);};
 char MyCable::ShowMyCableCTRL_MASK(void)      {return(CTRL_MASK);};
 char MyCable::ShowMyCableD6_MASK(void)        {return(D6_MASK);};
 char MyCable::ShowMyCableBUSY_MASK(void)      {return(BUSY_MASK);};
 char MyCable::ShowMyCablePE_MASK(void)        {return(PE_MASK);};

 //---
 char MyCable::ShowDataportValue(void)         {return(dataport_value);};
 char MyCable::GetPortData(void);

 //--  
 //   
 char MyCable::GetTdoData(void);
 bool MyCable::CheckPower(void);
 bool MyCable::CheckHW(void);

 void MyCable::UpdatePortDataCLK(void);
 void MyCable::UpdatePortData(void);


 //--  
char MyCable::SetPortDataInit(char ctdo, char ctrst, char ctms, char ctck,
                          char ctdi, char csrst, char cinit, char cprog,
													char cctrl);

String MyCable::_WriteBitCmd(char cTDI, char cTMS, String strComment, bool bMonitor/*, TRichEdit *pRichEdit*/);
String MyCable::RWriteBitCmd(char cTDI, char cTMS, String strComment, bool bMonitor/*, TRichEdit *pRichEdit*/);

};

//-----------------------------------------------------------------------------
#endif
