/* ***********************************************************************  
  FREE IP GENERAL PUBLIC LICENSE
  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION

  1.  You may copy and distribute verbatim copies of this core, as long
      as this file, and the other associated files, remain intact and
      unmodified.  Modifications are outlined below.  
  2.  You may use this core in any way, be it academic, commercial, or
      military.  Modified or not.  
  3.  Distribution of this file must be free of charge.  Charging is
      allowed only for value added services.  Value added services
      would include copying fees, modifications, customizations, and
      inclusion in other products.
  4.  If a modified source code is distributed, the original unmodified
      source code must also be included (or a link to my web
      site).  In the modified source code there must be clear
      identification of the modified version.
  5.  Visit the my web site for additional information.
      http://www.iosifk.narod.ru

*********************************************************************** */ 

////////////////////////////////////////////////////////////////////////
//	Name File		  : MyParPort.cpp  					    											//
//	Autor					: Iosif Karshenboim																	//
//	      				: www.iosifk.narod.ru																//
//	Description		: JTAG soft tool                    								//
//	Start design	: 23.08.2006																				//
//	Last revision	: 23.08.2006																				//
////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
// MyParPort.cpp: contain Func of LPT-Port.
//-----------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>

#pragma hdrstop
#include "MyParPort.h"

HANDLE h;

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
/*
int DP=0x378;           // data port
int SP=0x379;           // status port
int CP=0x37a;           // control port
DATA    PORTADDRESS=0x378
STATUS  PORTADDRESS=0x379
CONTROL PORTADDRESS=0x37a

*/

#define PORTADDRESS 0x378 /* Port Address for Parallel port, 0x378 for LPT1, 0x278 for LPT2 */
#define DATA PORTADDRESS+0
#define STATUS PORTADDRESS+1
#define CONTROL PORTADDRESS+2

//    ,          ...


//---------------------------------------------------------------------------

MyParPort::MyParPort() 
{
	 //*******************************************************
   h = CreateFile("\\\\.\\giveio", GENERIC_READ, 0, NULL,
                  OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

   if (h==INVALID_HANDLE_VALUE)
    {
     ShowMessage("    - giveio.sys driver");
     CloseHandle(h);
     }
     
   //*******************************************************
}
//---------------------------------------------------------------------------

MyParPort::~MyParPort()
{
 CloseHandle(h);  
}
//---------------------------------------------------------------------------

bool PortOpen (void)
{
 bool bOK = true;
   if (h==INVALID_HANDLE_VALUE)
    {
     ShowMessage("    - giveio.sys driver");
     CloseHandle(h);
     bOK=false;
     }
  return (bOK);
}
//---------------------------------------------------------------------------

void  MyParPort::WrData (char cData)          //
{
  WORD wAddr =WORD(PORTADDRESS);
  asm {  //  xor ax, ax
        mov al, byte ptr cData
        mov dx, wAddr
        out dx, al
     }
}

//---------------------------------------------------------------------------
void  MyParPort::WrStatus (char cData)
{
  WORD wAddr =WORD(PORTADDRESS+1);
  asm {  //  xor ax, ax
        mov al, byte ptr cData
        mov dx, wAddr
        out dx, al
     }
}
//---------------------------------------------------------------------------
void  MyParPort::WrControl (char cData)
{
  WORD wAddr =WORD(PORTADDRESS+2);
  asm {  //  xor ax, ax
        mov al, byte ptr cData
        mov dx, wAddr
        out dx, al
     }
}
//-----------------------------------------------------------------------------
void MyParPort::WriteByteToPort(int PortAddr, char cData)
{
 WORD wAddr =WORD(PortAddr);
 asm {  //  xor ax, ax
        mov al, byte ptr cData
        mov dx, wAddr
        out dx, al
     }  
}
//-----------------------------------------------------------------------------
BYTE MyParPort::ReadByteFromPort(int PortAddr)
{
WORD wAddr =WORD(PortAddr);
asm
  {
  xor     eax,eax
  mov     dx,wAddr
  in      al,dx
  }
}
//---------------------------------------------------------------------------
BYTE MyParPort::RdData(void)
{
 WORD wAddr =WORD(PORTADDRESS);
asm
  {
  xor     eax,eax
  mov     dx,wAddr
  in      al,dx
  }
}
//---------------------------------------------------------------------------
BYTE MyParPort::RdStatus(void)
{
 WORD wAddr =WORD(PORTADDRESS+1);
asm
  {
  xor     eax,eax
  mov     dx,wAddr
  in      al,dx
  }
}

//---------------------------------------------------------------------------
BYTE MyParPort::RdControl(void)
{
 WORD wAddr =WORD(PORTADDRESS+2);
asm
  {
  xor     eax,eax
  mov     dx,wAddr
  in      al,dx
  }
}
//---------------------------------------------------------------------------
