/* ***********************************************************************  
  FREE IP GENERAL PUBLIC LICENSE
  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION

  1.  You may copy and distribute verbatim copies of this core, as long
      as this file, and the other associated files, remain intact and
      unmodified.  Modifications are outlined below.  
  2.  You may use this core in any way, be it academic, commercial, or
      military.  Modified or not.  
  3.  Distribution of this file must be free of charge.  Charging is
      allowed only for value added services.  Value added services
      would include copying fees, modifications, customizations, and
      inclusion in other products.
  4.  If a modified source code is distributed, the original unmodified
      source code must also be included (or a link to my web
      site).  In the modified source code there must be clear
      identification of the modified version.
  5.  Visit the my web site for additional information.
      http://www.iosifk.narod.ru

*********************************************************************** */ 

////////////////////////////////////////////////////////////////////////
//	Name File		  : TAP.cpp  		      			    											//
//	Autor					: Iosif Karshenboim																	//
//	      				: www.iosifk.narod.ru																//
//	Description		: JTAG soft tool                    								//
//	Start design	: 23.08.2006																				//
//	Last revision	: 23.08.2006																				//
////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
// TAP.cpp:      .
//-----------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#include <sysdyn.h>
#include <inifiles.hpp>

#pragma hdrstop
#include "MyParPort.h"
#include "MyCable.h"
#include "CableTAP.h"
#include "MyTAP.h"
#include "MyStrings.h"
#include "Unit1.h"

extern MyTAP* CableP;
extern String strScanString;
extern String *pScanString;
//int state;
bool BitBangEndState(int next_state);
bool TapTransition (int next_state);
//bool TapTransitionScan (int end_state);

DynamicArray<char> IrScanWrite;   // WRITE DATA BYTE BUFFER
DynamicArray<char> IrScanRead;    // READ DATA BYTE BUFFER
DynamicArray<char> DrScanWrite;
DynamicArray<char> DrScanRead;


/*
void InitArray(DynamicArray<char> &c_array)

{
  c_array[0] = 'A';
  c_array[1] = 'B';
  cout << "Third char is: " << c_array[2];
}
*/



bool TapTransition (int Tdi, int end_state, String strComment, int MonitorLevel);

bool TapIrScan (String strScanStringCommand,
                DynamicArray<char> &IrScanWrite,/*, // WRITE DATA BYTE BUFFER
                DynamicArray<char> &IrScanRead */  // READ DATA BYTE BUFFER
                int TapEndState,
                int MonitorLevel);

String TapDrScan (int DataScanLength,
                DynamicArray<char> &DrScanWrite, // WRITE DATA BYTE BUFFER
                DynamicArray<char> &DrScanRead,  // READ DATA BYTE BUFFER
                int TapEndState,
                int MonitorLevel);

String strScanIrStringData, strScanDrStringData;

String ScanMyData (String strScanStringCommand,     //      
                 int DataBitsScanLength,          //    
                 bool bTwice,
                 DynamicArray<char> &DrScanWrite, // WRITE DATA BYTE BUFFER
                 DynamicArray<char> &DrScanRead,
                 int MonitorLevel); // READ DATA BYTE BUFFER

bool GetID (String strScanStringCommand,
                DynamicArray<char> &DrScanWrite, // WRITE DATA BYTE BUFFER
                DynamicArray<char> &DrScanRead,
                int MonitorLevel);  // READ DATA BYTE BUFFER

int GetChipNumber (int MonitorLevel);
bool OneStepInGrid (int MyItemFocused);


//---------------------------------------------------------------------------

MyTAP::MyTAP()
{
//  
 CableT = new CableTAP();
}
//---------------------------------------------------------------------------

MyTAP::~MyTAP()
{
 //  
 delete CableT;
}
//---------------------------------------------------------------------------
void MyTAP::SetParams(String strNewName,
                          char tdo, char trst, char tms, char tck,
                          char tdi, char srst, char o_inv, char i_inv,
                          char init, char vcc_sense, char prog,
													char ctrl, char d6, char busy, char pe)

{ // 
  CableT->CableTAPSetParams(strNewName, tdo, trst, tms, tck, tdi, srst, o_inv,
                           i_inv, init, vcc_sense, prog, ctrl, d6, busy, pe);
}
//---------------------------------------------------------------------------
 bool MyTAP::TAPInit(char init, char tdo, char trst, char tms, char tdi, char srst, char tck, char prog, char ctrl)
{
  bool bOK=true;
	// 
  bool cTmp = CableT->CableTAPInit(init, tdo, trst, tms, tdi, srst, tck, prog, ctrl);

  if(!cTmp)
   bOK = false;
  return (bOK);
}
//---------------------------------------------------------------------------
String MyTAP::ShowTAPName(void)
{
 String strTmp = CableT->ShowCableTAPName(); return(strTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPTDO_MASK(void)
{
 char cTmp = CableT->ShowCableTAPTDO_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPTRST_MASK(void)
{
 char cTmp = CableT->ShowCableTAPTRST_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPTMS_MASK(void)
{
 char cTmp = CableT->ShowCableTAPTMS_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPTCK_MASK(void)
{
 char cTmp = CableT->ShowCableTAPTCK_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPTDI_MASK(void)
{
 char cTmp = CableT->ShowCableTAPTDI_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPSRST_MASK(void)
{
 char cTmp = CableT->ShowCableTAPSRST_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPOUTPUT_INVERT(void)
{
 char cTmp = CableT->ShowCableTAPOUTPUT_INVERT(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPINPUT_INVERT(void)
{
 char cTmp = CableT->ShowCableTAPINPUT_INVERT(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPPORT_INIT(void)
{
 char cTmp = CableT->ShowCableTAPPORT_INIT();  return(cTmp);
}
//---------------------------------------------------------------------------
 String MyTAP::ShowTAP_AllParams(void)
{
 String strTmp =
 "cable->name - "            + CableT->ShowCableTAPName() + "\n" +
 "cable->TDO_MASK      - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPTDO_MASK()), 2     ) + "\n" +
 "cable->TRST_MASK     - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPTRST_MASK()), 2    ) + "\n" +
 "cable->TMS_MASK      - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPTMS_MASK()), 2     ) + "\n" +
 "cable->TCK_MASK      - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPTCK_MASK()), 2     ) + "\n" +
 "cable->TDI_MASK      - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPTDI_MASK()), 2     ) + "\n" +
 "cable->SRST_MASK     - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPSRST_MASK()), 2    ) + "\n" +
 "cable->OUTPUT_INVERT - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPOUTPUT_INVERT()), 2) + "\n" +
 "cable->INPUT_INVERT  - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPINPUT_INVERT()), 2 ) + "\n" +
 "cable->PORT_INIT     - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPPORT_INIT()), 2    ) + "\n" +

 "cable->VCC_SENSE     - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPVCC_SENSE()), 2    ) + "\n" +
 "cable->PROG_MASK     - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPPROG_MASK()), 2    ) + "\n" +
 "cable->CTRL_MASK     - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPCTRL_MASK()), 2    ) + "\n" +
 "cable->D6_MASK       - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPD6_MASK()), 2      ) + "\n" +
 "cable->BUSY_MASK     - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPBUSY_MASK()), 2    ) + "\n" +
 "cable->PE_MASK       - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPPE_MASK()), 2      ) + "\n";


 return(strTmp);
}
//---------------------------------------------------------------------------
//--  
//---------------------------------------------------------------------------
char MyTAP::ShowTAPVCC_SENSE(void)
{
 char cTmp = CableT->ShowCableTAPVCC_SENSE(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPPROG_MASK(void)
{
 char cTmp = CableT->ShowCableTAPPROG_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPCTRL_MASK(void)
{
 char cTmp = CableT->ShowCableTAPCTRL_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPD6_MASK(void)
{
 char cTmp = CableT->ShowCableTAPD6_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPBUSY_MASK(void)
{
 char cTmp = CableT->ShowCableTAPBUSY_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPPE_MASK(void)
{
 char cTmp = CableT->ShowCableTAPPE_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------

//   
char MyTAP::GetTdoData(void)
{
 char cTmp = CableT->GetTdoData(); return(cTmp);
}
//---------------------------------------------------------------------------
bool MyTAP::CheckPower(void)
{
 char cTmp = CableT->CheckPower(); return(cTmp);
}
//---------------------------------------------------------------------------
bool MyTAP::CheckHW(void)
{
 char cTmp = CableT->CheckHW(); return(cTmp);
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
char MyTAP::ShowDataportValue(void)
{
 char cTmp = CableT->ShowDataportValue();
 return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::GetDataportValue(void)
{
 char cTmp = CableT->GetDataportValue();
 return(cTmp);
}

//---------------------------------------------------------------------------
//  tms  tdi   N - ,  
//---------------------------------------------------------------------------

void MyTAP::WriteTMS_SetTDI(char tms, char tdi, char N, String strComment, int MonitorLevel)
{
 bool bMonitor;
  if (MonitorLevel >=5)
    bMonitor=true;
  else
    bMonitor=false;

 CableT->WriteTMS_SetTDI(tms, tdi, N, strComment, bMonitor);

 if(MonitorLevel>=4)
   Form1->RichEdit1->Lines->Add(strComment
           + ", tms - 0x" +  IntToHex(tms, 2)
           + ", tdi - 0x" +  IntToHex(tdi, 2)
           + ", N - 0x"   +  IntToHex(N, 2));
 }
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//  tms  tdi   
//     
// N - ,  
//---------------------------------------------------------------------------

String MyTAP::RdWriteTMS_SetTDI(char tms, char tdi, char N, String strComment, int MonitorLevel)
{
 bool bMonitor;
  if (MonitorLevel >=5)
    bMonitor=true;
  else
    bMonitor=false;

	String strScanIn = CableT->RdWriteTMS_SetTDI(tms, tdi, N, strComment, bMonitor);

 if(MonitorLevel>=4)
  Form1->RichEdit1->Lines->Add(strComment
           + ", tms - 0x" +  IntToHex(tms, 2)
           + ", tdi - 0x" +  IntToHex(tdi, 2)
           + ", N - 0x"   +  IntToHex(N, 2)
           + ", RdWriteTMS_SetTDI strScanIn - "   +  strScanIn);
	return (strScanIn);
}
//---------------------------------------------------------------------------
String MyTAP::RdLastTDI(void)
{
	String strScanIn = CableT->RdLastTDI();
   Form1->RichEdit1->Lines->Add("Last strScanIn - " +  strScanIn);

	return (strScanIn);
}
//---------------------------------------------------------------------------

/*
typedef struct tap_transition_s
{
	enum tap_state high;
	enum tap_state low;
} tap_transition_t;

extern char* tap_state_strings[16];
extern int tap_move_map[16];	//* map 16 TAP states to 6 stable states *
extern u8 tap_move[6][6];		//* value scanned to TMS to move from one of six stable states to another *
extern tap_transition_t tap_transitions[16];	//* describe the TAP state diagram *
*/
//---------------------------------------------------------------------------
/* Tap States
 * TLR - Test-Logic-Reset, RTI - Run-Test/Idle,
 * SDS - Select-DR-Scan, CD - Capture-DR, SD - Shift-DR, E1D - Exit1-DR,
 * PD - Pause-DR, E2D - Exit2-DR, UD - Update-DR,
 * SIS - Select-IR-Scan, CI - Capture-IR, SI - Shift-IR, E1I - Exit1-IR,
 * PI - Pause-IR, E2I - Exit2-IR, UI - Update-IR
 */

enum tap_state
{// Tap States
	TAP_TLR = 0x0,			//  0, 		 TLR - Test-Logic-Reset
	TAP_SDS = 0x1,			//	-1,		 SDS - Select-DR-Scan
	TAP_CD  = 0x2,			//	-1,    CD - Capture-DR
	TAP_SD  = 0x3,			//	2,     SD - Shift-DR
	TAP_E1D = 0x4,			//	-1,		 E1D - Exit1-DR
	TAP_PD  = 0x5,			//	3,     PD - Pause-DR
	TAP_E2D = 0x6,			//	-1,		 E2D - Exit2-DR
	TAP_UD  = 0x7,			//	6,     UD - Update-DR
	TAP_RTI = 0x8,			//	1, 		 RTI - Run-Test/Idle
	TAP_SIS = 0x9,			//	-1,		 SIS - Select-IR-Scan
	TAP_CI  = 0xa,			//	-1,    CI - Capture-IR
	TAP_SI  = 0xb,			//	4,     SI - Shift-IR
	TAP_E1I = 0xc,			//	-1,		 E1I - Exit1-IR
	TAP_PI  = 0xd,			//	5,     PI - Pause-IR
	TAP_E2I = 0xe,			//	-1,		 E2I - Exit2-IR
	TAP_UI  = 0xf			  //	7      UI - Update-IR
};
enum tap_state end_state = TAP_TLR;   // finish DR scans in dr_end_state
enum tap_state cur_state = TAP_TLR;   // current TAP state

/*
char* tap_state_strings[16] =
{
	"tlr", 
	"sds", "cd", "sd", "e1d", "pd", "e2d", "ud",
	"rti",
	"sis", "ci", "si", "e1i", "pi", "e2i", "ui"
};
*/
/*
tap_transition_t tap_transitions[16] =
{
	{TAP_TLR, TAP_RTI},		// TLR //
	{TAP_SIS, TAP_CD},		// SDS //
	{TAP_E1D, TAP_SD},		// CD  //
	{TAP_E1D, TAP_SD},		// SD  //
	{TAP_UD,  TAP_PD}, 		// E1D //
	{TAP_E2D, TAP_PD},		// PD  //
	{TAP_UD,  TAP_SD},		// E2D //
	{TAP_SDS, TAP_RTI},		// UD  //
	{TAP_SDS, TAP_RTI},		// RTI //
	{TAP_TLR, TAP_CI},		// SIS //
	{TAP_E1I, TAP_SI},		// CI  //
	{TAP_E1I, TAP_SI},		// SI  //
	{TAP_UI,  TAP_PI}, 		// E1I //
	{TAP_E2I, TAP_PI},		// PI  //
	{TAP_UI,  TAP_SI},		// E2I //
	{TAP_SDS, TAP_RTI}		// UI  //
};
*/


//---------------------------------------------------------------------------
//      TAP  ...
//  16    5 !!!
//---------------------------------------------------------------------------

int tap_move_map[16] = {
	0, -1, -1,  2, -1,  3, -1,  6,
	1, -1, -1,  4, -1,  5, -1,  7
};

// tap_move[i][j]: tap movement command to go from state i to state j
// 0: Test-Logic-Reset
// 1: Run-Test/Idle
// 2: Shift-DR
// 3: Pause-DR
// 4: Shift-IR
// 5: Pause-IR 
// 6: Update-DR
// 7: Update-IR

char TapMove[8][8][2] =
{ //   -    
  //   -    
	
	/*      
	//	  TLR           RTI            SD          PD             SI             PI             
	{{0x00, 0x00}, {0x01, 0x00}, {0x02, 0x00}, {0x03, 0x00}, {0x04, 0x00}, {0x05, 0x00}},	// TLR 
	{{0x00, 0x01}, {0x01, 0x01}, {0x02, 0x01}, {0x03, 0x01}, {0x04, 0x01}, {0x05, 0x01}},	// RTI 
	{{0x00, 0x02}, {0x01, 0x02}, {0x02, 0x02}, {0x03, 0x02}, {0x04, 0x02}, {0x05, 0x02}},	// SD  
	{{0x00, 0x03}, {0x01, 0x03}, {0x02, 0x03}, {0x03, 0x03}, {0x04, 0x03}, {0x05, 0x03}},	// PD  
	{{0x00, 0x04}, {0x01, 0x04}, {0x02, 0x04}, {0x03, 0x04}, {0x04, 0x04}, {0x05, 0x04}},	// SI  
	{{0x00, 0x05}, {0x01, 0x05}, {0x02, 0x05}, {0x03, 0x05}, {0x04, 0x05}, {0x05, 0x05}}	// PI
	{{0x00, 0x06}, {0x01, 0x06}, {0x02, 0x06}, {0x03, 0x06}, {0x04, 0x06}, {0x05, 0x06}},	// UDR  
	{{0x00, 0x07}, {0x01, 0x07}, {0x02, 0x07}, {0x03, 0x07}, {0x04, 0x07}, {0x05, 0x07}}	// UIR


	//        
	//	  TLR              RTI             SD            PD             SI               PI                UDR              UIR
	{{ 1,        1 }, { 0,      1 }, { 0010,    4 }, {010010, 6},  { 00110,    5},  { 1000110, 7},    { 1000110, 7}},	  { 1000110, 7}},	// TLR
	{{ 1110,     4 }, { 0,      1 }, { 001,     3 }, {10001,  5},  { 0011,     4},  { 100011,  6},	  { 100011,  6}},	  { 100011,  6}},	// RTI
	{{ 11101101, 8 }, { 01101,  5 }, { 0,       1 }, {01,     2},  { 00111101, 8},  { 0,       0},	  { 0,       0}},	  { 0,       0}},	// SD 
	{{ 11111,    5 }, { 011,    3 }, { 00111,   5 }, {0,      1},  { 001111,   6},  { 0,       0},	  { 0,       0}},	  { 0,       0}},	// PD 
	{{ 1111101,  7 }, { 01101,  5 }, { 0011101, 7 }, {0,      0},  { 0,        1},  { 01,      2},	  { 01,      2}},	  { 01,      2}},	// SI 
	{{ 11111,    5 }, { 011,    3 }, { 00111,   5 }, {0,      0},  { 001111,   6},  { 0,       1},	  { 0,       1}},	  { 0,       1}},	// PI 
	{{ 1110,     4 }, { 0,      1 }, { 001,     3 }, {01001,  5 }, { 010011,   6},  { 0,       0},	  { 0,       0}},	  { 0,       0}},	// UDR 
	{{ 1110,     4 }, { 0,      1 }, { 001,     3 }, {01001,  5 }, { 010011,   6},  { 0,       0},	  { 0,       0}},	  { 0,       0}}	// UIR 

*/
	
	//   TLR        RTI       SD         PD         SI        PI          UDR       UIR      
	{{ 0x1,  1}, {0,   1}, {0x2,  4}, {0x12, 6}, {0x6,  5}, {0x46, 7}, {0x6, 5}, {0x46, 7}},	// TLR
	{{ 0xE,  4}, {0,   1}, {0x1,  3}, {0x11, 5}, {0x3,  4}, {0x23, 6}, {0x3, 4}, {0x23, 6}},	// RTI
	{{ 0xED, 8}, {0x3, 3}, {0,    1}, {0x1,  2}, {0x3D, 8}, {0,    0}, {0x3D,8}, {0,    0}},	// SD
	{{ 0x1F, 5}, {0x3, 3}, {0x7,  5}, {0,    1}, {0xF,  6}, {0,    0}, {0xF, 6}, {0,    0}},	// PD 
	{{ 0x7D, 7}, {0xD, 5}, {0xB,  5}, {0,    0}, {0,    1}, {0x1,  2}, {0,   1}, {0x1,  2}},	// SI 
	{{ 0x1F, 5}, {0x3, 3}, {0x3,  5}, {0,    0}, {0xF,  6}, {0,    1}, {0xF, 6}, {0,    1}},  // PI
	{{ 0xE,  4}, {0,   1}, {1,    3}, {9,    5}, {0x13, 6}, {0,    0}, {0,   0}, {0,    0}},	// UDR 
	{{ 0xE,  4}, {0,   1}, {1,    3}, {9,    5}, {0x13, 6}, {0,    0}, {0,   0}, {0,    0}}	  // UIR

};


//---------------------------------------------------------------------------
bool BitBangEndState(int end_state)
{
	bool bOK = true;
	//   ,    
	if (tap_move_map[end_state] != -1)
		end_state = end_state;
	else
	{
//		ERROR("BUG: %i is not a valid end state", state);
		ShowMessage("BUG: 0x" +  IntToHex(end_state, 2) + " - is not a valid end state");
		bOK = false;
	}
	return(bOK);
}
//---------------------------------------------------------------------------
bool TapTransition (int Tdi, int end_state, String strComment, int MonitorLevel)
{
	bool bOK = true;

	//   ,    
	if (tap_move_map[end_state] != -1)
   {
     CableP->WriteTMS_SetTDI(TapMove[tap_move_map[cur_state]][tap_move_map[end_state]][0],     // char tms
                             Tdi,
														 TapMove[tap_move_map[cur_state]][tap_move_map[end_state]][1],     // char N
                             strComment,
                             MonitorLevel);

		 cur_state = end_state;

     if(MonitorLevel>=3)
      {
       Form1->RichEdit1->Lines->Add("cur_state - 0x" +  IntToHex(cur_state, 2));
       Form1->RichEdit1->Lines->Add("  - 0x" +  IntToHex(tap_move_map[end_state], 2));
       }
    }
	else
	{
		ShowMessage("BUG: 0x" +  IntToHex(end_state, 2) + " - is not a valid end state");
		bOK = false;
	}

	return(bOK);
}
//---------------------------------------------------------------------------

bool TapIrScan (String strScanStringCommand,
                DynamicArray<char> &IrScanWrite,/*, // WRITE DATA BYTE BUFFER
                DynamicArray<char> &IrScanRead*/   // READ DATA BYTE BUFFER
                int TapEndState,
                int MonitorLevel)
{
	bool bOK = true;

  //**********************************************************************
	//    ,   ,    .
  //**********************************************************************
  end_state = TAP_TLR;

  String strTmp;
  if(MonitorLevel==0)
     strTmp = "";
  else
     strTmp = "  TAP_TLR";

	CableP->WriteTMS_SetTDI(0x1F,     // char tms
                          0,        // char tdi
											    5,       // char N
                          strTmp,
                          MonitorLevel);
	cur_state = end_state;


  //**********************************************************************
	//     .
  //**********************************************************************
  end_state = TAP_SI;

  if(MonitorLevel!=0)
     strTmp = "  TAP_SI";


	CableP->WriteTMS_SetTDI(TapMove[tap_move_map[cur_state]][tap_move_map[end_state]][0],     // char tms
                          0,
											    TapMove[tap_move_map[cur_state]][tap_move_map[end_state]][1],    // char N
                          strTmp,
                          MonitorLevel);
  cur_state = end_state;

  //**********************************************************************
  //       
  //**********************************************************************
  String IrCommandScan, IrCommandScanByte;
	
  //      "strScanStringCommand"
  String strLastBit  = strScanStringCommand[1];          //   !!!
  int NumBitsToWrite = strScanStringCommand.Length();    //    
  //     "  ,  "
  String strScanStringCommandMinusOneBit = strScanStringCommand.SubString(2, NumBitsToWrite - 1);

  //    "char"
  BitStringToHex(strScanStringCommandMinusOneBit, IrScanWrite); //      IrScanWrite

  if(MonitorLevel !=0)
     strTmp = "   ";

  //    1-,       8 
  if (IrScanWrite.Length >1)
   {
     //     
	   for (int i=0; i < IrScanWrite.Length-1; i++)
	    {
       // tms = 0,       !!!
       IrCommandScanByte = CableP->RdWriteTMS_SetTDI(0, IrScanWrite[i], 8, strTmp, MonitorLevel);  // String,     
       IrCommandScan = IrCommandScanByte + IrCommandScan;
	    }
    }
    if(MonitorLevel !=0)
      strTmp = "    ";
    //       
	  // tms = 0,       !!!
    int Tmp1 = IrScanWrite[IrScanWrite.Length-1];
    int Tmp2 = (NumBitsToWrite - 1)%8;
    IrCommandScanByte = CableP->RdWriteTMS_SetTDI(0, Tmp1, Tmp2, strTmp, MonitorLevel);  // String
    IrCommandScan = IrCommandScanByte + IrCommandScan;


  //**********************************************************************
  //       ->     ...
  //**********************************************************************
	char LastBit = StrToInt(strLastBit); //Tdi

	//        TAP_RTI
	end_state = TapEndState;
  if(MonitorLevel !=0)
     strTmp = "       TapEndState";

	String IrCommandScanLB =
     CableP->RdWriteTMS_SetTDI(TapMove[tap_move_map[cur_state]][tap_move_map[end_state]][0],     // char tms
                               LastBit,                                                          // char Tdi
														   TapMove[tap_move_map[cur_state]][tap_move_map[end_state]][1],     // char N
                               strTmp,
                               MonitorLevel);
	cur_state = end_state;
  String strTmp3 = IrCommandScanLB.SubString(IrCommandScanLB.Length(), 1);
	String IrScan  = strTmp3 + IrCommandScan;

	if(MonitorLevel>=3)
    {
		 Form1->RichEdit1->Lines->Add("cur_state - 0x" +  IntToHex(cur_state, 2));
     Form1->RichEdit1->Lines->Add("  - 0x" +  IntToHex(tap_move_map[end_state], 2));
     Form1->RichEdit1->Lines->Add("String IrScan - " +  IrScan);
     }
     strScanIrStringData = IrScan;

	return(bOK);
  
} 
//---------------------------------------------------------------------------

String TapDrScan (int DataScanLength,
                DynamicArray<char> &DrScanWrite, // WRITE DATA BYTE BUFFER
                DynamicArray<char> &DrScanRead,  // READ DATA BYTE BUFFER
                tap_state TapEndState,
                int MonitorLevel)
{
// bool bOK = true;

  //**********************************************************************
	//  ,      .
  //**********************************************************************
  String strTmp;
  if(MonitorLevel==0)
     strTmp = "";
  else
     strTmp = "  TAP_SD,    TAP_SD";

 if(cur_state != TAP_SD)
  {
   end_state = TAP_SD;
	 CableP->WriteTMS_SetTDI(TapMove[tap_move_map[cur_state]][tap_move_map[end_state]][0],     // char tms
                           0,
											     TapMove[tap_move_map[cur_state]][tap_move_map[end_state]][1],    // char N
                           strTmp,
                           MonitorLevel);
   cur_state = end_state;
   }

  //**********************************************************************
  //       
  //**********************************************************************
  String DrDataScan, DrScanByte;
	
  //       "DrScanWrite"
	char cLastBit, cLastBitNumber, cLastByte;

  if ((DataScanLength%8)==0)
    cLastBitNumber = 7;
  else
    cLastBitNumber = (DataScanLength%8) - 1;

	cLastBit = (DrScanWrite[DrScanWrite.Length-1]) >> cLastBitNumber;

	//*****************************************************************

  int NumBitsToWrite = DataScanLength-1;    //    

  //    
  int BytesNumber;  //    

  if ((NumBitsToWrite%8)==0)
    BytesNumber = (NumBitsToWrite/8);
  else
    BytesNumber = (NumBitsToWrite/8) + 1;

  DrScanWrite.Length = BytesNumber;

 if(MonitorLevel !=0)
     strTmp = "   ";

	//    1-,       8 
  if (DrScanWrite.Length >1)
   {
       //     
	   for (int i=0; i < (NumBitsToWrite/8); i++)
	    {
       // tms = 0,       !!!
       DrScanByte = CableP->RdWriteTMS_SetTDI(0, DrScanWrite[i], 8, strTmp, MonitorLevel);  // String,     
       DrDataScan = DrScanByte + DrDataScan;


	    }
    }
     int Tmp2 = (NumBitsToWrite)%8;
     if(Tmp2>0)
      {

       if(MonitorLevel !=0)
       strTmp = "    ";
    //       
	  // tms = 0,       !!!
       int Tmp1 = DrScanWrite[DrScanWrite.Length-1];

      DrScanByte = CableP->RdWriteTMS_SetTDI(0, Tmp1, Tmp2, strTmp, MonitorLevel);  // String
      DrDataScan = DrScanByte + DrDataScan;

    //    !!!
    // DrDataScan = CableP->RdLastTDI() + DrScanByte + DrDataScan;
      }

	//**********************************************************************
  //       ->     ...
  //**********************************************************************

	//        TAP_TLR
	end_state = TapEndState;

  if(MonitorLevel !=0)
       strTmp = "      TapEndState";

	String DrDataScanLB =
     CableP->RdWriteTMS_SetTDI(TapMove[tap_move_map[cur_state]][tap_move_map[end_state]][0],     // char tms
                               cLastBit,                                                          // char Tdi
														   TapMove[tap_move_map[cur_state]][tap_move_map[end_state]][1],     // char N
                               strTmp,
                               MonitorLevel);

	cur_state = end_state;
  String strTmp3 = DrDataScanLB.SubString(DrDataScanLB.Length()-1, 2);
	String DrScan  = strTmp3 + DrDataScan;
 if(MonitorLevel>=3)
  {
		 Form1->RichEdit1->Lines->Add("cur_state - 0x" +  IntToHex(cur_state, 2));
     Form1->RichEdit1->Lines->Add("  - 0x" +  IntToHex(tap_move_map[end_state], 2));
     Form1->RichEdit1->Lines->Add("String DrScan - " +  DrScan);
     }
     strScanDrStringData = DrScan.SubString(1, DrScan.Length()-1);
	return(strScanDrStringData);
} 
//---------------------------------------------------------------------------
bool GetID (String strScanStringCommand,
                DynamicArray<char> &DrScanWrite, // WRITE DATA BYTE BUFFER
                DynamicArray<char> &DrScanRead,
                int MonitorLevel)  // READ DATA BYTE BUFFER
{
 
 bool bOK = true;

     TapIrScan (strScanStringCommand,
                IrScanWrite,/*, // WRITE DATA BYTE BUFFER
                DynamicArray<char> &IrScanRead */  // READ DATA BYTE BUFFER
                TAP_SD,
                MonitorLevel); //

DrScanWrite.Length = 5;
DrScanWrite[0] = 0;
DrScanWrite[1] = 0;
DrScanWrite[2] = 0;
DrScanWrite[3] = 0;
DrScanWrite[4] = 0;

DrScanRead.Length = 5;
DrScanRead[0] = 0;
DrScanRead[1] = 0;
DrScanRead[2] = 0;
DrScanRead[3] = 0;
DrScanRead[4] = 0;


     TapDrScan (32,           // 32
                DrScanWrite, // WRITE DATA BYTE BUFFER
                DrScanRead,  // READ DATA BYTE BUFFER
                TAP_RTI,
                MonitorLevel);

 //  strScanDrStringData = strScanDrStringData.SubString(1, strScanDrStringData.Length()-1);

   if(MonitorLevel>0)
    {
     Form1->RichEdit1->Lines->Add("TapIrScan - "  + strScanIrStringData);
     Form1->RichEdit1->Lines->Add("TapDrScan - "  + strScanDrStringData);
     }
     
	return(bOK);
}
//---------------------------------------------------------------------------
//   -       
//      WRITE DATA BYTE BUFFER
//     WRITE DATA BYTE BUFFER  READ DATA BYTE BUFFER

String ScanMyData (String strScanStringCommand,     //      
                 int DataBitsScanLength,          //    
                 bool bTwice,
                 DynamicArray<char> &DrScanWrite, // WRITE DATA BYTE BUFFER
                 DynamicArray<char> &DrScanRead,
                 int MonitorLevel)  // READ DATA BYTE BUFFER
{
 
 String strScanData;

     TapIrScan (strScanStringCommand,
                IrScanWrite,/*, // WRITE DATA BYTE BUFFER
                DynamicArray<char> &IrScanRead */  // READ DATA BYTE BUFFER
                TAP_SD,
                MonitorLevel); //
    if(bTwice)
     {
      TapDrScan (DataBitsScanLength,
                 DrScanWrite, // WRITE DATA BYTE BUFFER
                 DrScanRead,  // READ DATA BYTE BUFFER
                 TAP_UD,
                 MonitorLevel);
        }

      strScanData =
      TapDrScan (DataBitsScanLength,
                 DrScanWrite, // WRITE DATA BYTE BUFFER
                 DrScanRead,  // READ DATA BYTE BUFFER
                 TAP_RTI,
                 MonitorLevel);



	return(strScanData);
}
//---------------------------------------------------------------------------
int GetChipNumber (int MonitorLevel)
{
	 //  ,      JTAG    
   TIniFile *ini;
   ini = new TIniFile(ChangeFileExt(Application->ExeName, ".INI" ) );
   String strTapValidateString = ini->ReadString( "TapValidateBSR", "TapValidateString", "1001010110111" );
   int MaxChipNumber = ini->ReadInteger( "TapValidateBSR", "MaxChipNumber", 60);
   delete ini;

  // ,      "bypass" <= 20 ...
	//      "MaxChipNumber" :
	 String strTotalBypassCommand = AnsiString::StringOfChar('1', MaxChipNumber*20);

  //        "bypass"
     TapIrScan (strTotalBypassCommand,
                IrScanWrite,/*, // WRITE DATA BYTE BUFFER
                DynamicArray<char> &IrScanRead */  // READ DATA BYTE BUFFER
                TAP_SD,
                MonitorLevel);

	//          -   ,    .
	 String strBSR = AnsiString::StringOfChar('0', MaxChipNumber) + strTapValidateString + AnsiString::StringOfChar('0', 1);

  //              
  BitStringToHex(strBSR, DrScanWrite);

	DrScanRead.Length = DrScanWrite.Length;


     TapDrScan (strBSR.Length(),
                DrScanWrite,  // WRITE DATA BYTE BUFFER
                DrScanRead,   // READ DATA BYTE BUFFER
                TAP_TLR,
                MonitorLevel);
  //     "strScanDrStringData"


 int FindSubStringPos = strScanDrStringData.Pos(strTapValidateString);
 int ChipNumber;

 if(FindSubStringPos==NULL)
   ChipNumber = 0;
 else
   ChipNumber = strScanDrStringData.Length()- strTapValidateString.Length() - FindSubStringPos + 1;

 if(MonitorLevel>=2)
  {
 Form1->RichEdit1->Lines->Add("strTapValidateString - " + strTapValidateString);
 Form1->RichEdit1->Lines->Add(" strTotalBypassCommand - " + strTotalBypassCommand);
 Form1->RichEdit1->Lines->Add(" strBSR - " + strBSR);
 Form1->RichEdit1->Lines->Add(" strScanDrStringData - " + strScanDrStringData);
 Form1->RichEdit1->Lines->Add("ChipNumber,  - " +IntToStr(ChipNumber));
  }
 return(ChipNumber);
 
}
//-------------------------------------------------------------------------------
bool OneStepInGrid (int MyItemFocused)
{
//  bool
 bool bOK = true;

// Test #;BP;Scan Command;Scan Addr;TapDrData;DataBitsLength;TapEndState;Comment
//  0      1     2          3          4           5             6          7

   String strOneCell = Trim(Form1->StringGrid1->Cells[7][MyItemFocused]);
   Form1->RichEdit1->Lines->Add(" - " + IntToStr(MyItemFocused) + " " + strOneCell);

   strOneCell = Trim(Form1->StringGrid1->Cells[6][MyItemFocused]);

  tap_state TapEndState;
/*
	TAP_TLR = 0x0,			//  0, 		 TLR - Test-Logic-Reset
	TAP_SDS = 0x1,			//	-1,		 SDS - Select-DR-Scan
	TAP_CD  = 0x2,			//	-1,    CD - Capture-DR
	TAP_SD  = 0x3,			//	2,     SD - Shift-DR
	TAP_E1D = 0x4,			//	-1,		 E1D - Exit1-DR
	TAP_PD  = 0x5,			//	3,     PD - Pause-DR
	TAP_E2D = 0x6,			//	-1,		 E2D - Exit2-DR
	TAP_UD  = 0x7,			//	-1,    UD - Update-DR
	TAP_RTI = 0x8,			//	1, 		 RTI - Run-Test/Idle
	TAP_SIS = 0x9,			//	-1,		 SIS - Select-IR-Scan
	TAP_CI  = 0xa,			//	-1,    CI - Capture-IR
	TAP_SI  = 0xb,			//	4,     SI - Shift-IR
	TAP_E1I = 0xc,			//	-1,		 E1I - Exit1-IR
	TAP_PI  = 0xd,			//	5,     PI - Pause-IR
	TAP_E2I = 0xe,			//	-1,		 E2I - Exit2-IR
	TAP_UI  = 0xf			  //	-1     UI - Update-IR
*/
  String strDataBitsLength = Trim(Form1->StringGrid1->Cells[5][MyItemFocused]);
//  int DataBitsLength;
  String strTapDrData      = Trim(Form1->StringGrid1->Cells[4][MyItemFocused]);
  String strScanAddr  = (Trim(Form1->StringGrid1->Cells[3][MyItemFocused]));
	String strScanAddrCode = "";

  if(strOneCell != "")
   {
    if(strOneCell == "Run-Test/Idle")
     TapEndState = TAP_RTI;
    else if(strOneCell == "Test-Logic-Reset")
     TapEndState = TAP_TLR;
    else if(strOneCell == "Shift-IR")
     TapEndState = TAP_SI;
    else if(strOneCell == "Shift-DR")
     TapEndState = TAP_SD;
    else if(strOneCell == "Update-DR")
     TapEndState = TAP_UD;
    else
     TapEndState = StrToInt(strOneCell);
    }
  else
   {
    if(Trim(Form1->StringGrid1->Cells[2][MyItemFocused]) != "Get ID")
     {
      ShowMessage(" TapEndState!  -" + IntToStr(MyItemFocused));
      bOK = false;
      }
    }


  if((Trim(Form1->StringGrid1->Cells[2][MyItemFocused])=="Get ID")&& bOK)
    GetID (Form1->Edit20->Text,
               DrScanWrite,  // WRITE DATA BYTE BUFFER
               DrScanRead,   // READ DATA BYTE BUFFER
               Form1->ComboBox3->ItemIndex);  //  

  if((Trim(Form1->StringGrid1->Cells[2][MyItemFocused])=="TapIrScan")&& bOK)
   {
    //--------------
    if(strScanAddr != "")
     {
      //--------------
      if(strScanAddr == "Addr=USER1")
    	 strScanAddrCode = Form1->Edit29->Text;
    	else if(strScanAddr == "Addr=USER2")
    	 strScanAddrCode = Form1->Edit30->Text;
    	else if(strScanAddr == "Addr=Bypass")
    	 strScanAddrCode = Form1->Edit19->Text;
    	else if(strScanAddr == "Addr=ID")
			 strScanAddrCode = Form1->Edit20->Text;
    	else if(strScanAddr == "Addr=USERCODE")        
    	 strScanAddrCode = Form1->Edit21->Text;                        
    	else                                       
    	 strScanAddrCode = StrToInt(strScanAddr);     

      //--------------
			//  ...
      TapIrScan (strScanAddrCode,
                IrScanWrite,/*, // WRITE DATA BYTE BUFFER
                DynamicArray<char> &IrScanRead */  // READ DATA BYTE BUFFER
                TapEndState,
                Form1->ComboBox3->ItemIndex); //
      //--------------
      }
    else
     {
      ShowMessage("  ScanAddr!  -" + IntToStr(MyItemFocused));
      bOK = false;
      }
    //--------------
    }
  else if(Trim(Form1->StringGrid1->Cells[2][MyItemFocused])=="TapDrScan")
   {
    //--------------
    if(strDataBitsLength != "")
     {
//      DataBitsLength  = StrToInt(strDataBitsLength);       // ??????????????????????????
      //--------------
      if(strDataBitsLength != 0)
       {
        //--------------
        if(strTapDrData != "")
         {
          //--------------
					//    - strTapDrData   
					//              
          BitStringToHex(strTapDrData, DrScanWrite);

	        DrScanRead.Length = DrScanWrite.Length;

          Form1->RichEdit1->Lines->Add("TapDrScan - " +
          TapDrScan (strTapDrData.Length(),
                     DrScanWrite,  // WRITE DATA BYTE BUFFER
                     DrScanRead,   // READ DATA BYTE BUFFER
                     TapEndState,  // TapEndState TAP_TLR
                     Form1->ComboBox3->ItemIndex ));                //  


         // Form1->RichEdit1->Lines->Add("TapDrScan - " + IntToStr(MyItemFocused));

					//--------------
				 }
       else
				 {
          ShowMessage("    !  -" + IntToStr(MyItemFocused));
          bOK = false;
				  }
				//--------------
			 }
      else
       {
        ShowMessage("    = 0!  -" + IntToStr(MyItemFocused));
        bOK = false;
			 }
			//--------------
		}
  else
   {
    ShowMessage("     !  -" + IntToStr(MyItemFocused));
    bOK = false;
    }
   } 
 	return(bOK);
}
//-------------------------------------------------------------------------------

