/* ***********************************************************************  
  FREE IP GENERAL PUBLIC LICENSE
  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION

  1.  You may copy and distribute verbatim copies of this core, as long
      as this file, and the other associated files, remain intact and
      unmodified.  Modifications are outlined below.  
  2.  You may use this core in any way, be it academic, commercial, or
      military.  Modified or not.  
  3.  Distribution of this file must be free of charge.  Charging is
      allowed only for value added services.  Value added services
      would include copying fees, modifications, customizations, and
      inclusion in other products.
  4.  If a modified source code is distributed, the original unmodified
      source code must also be included (or a link to my web
      site).  In the modified source code there must be clear
      identification of the modified version.
  5.  Visit the my web site for additional information.
      http://www.iosifk.narod.ru

*********************************************************************** */ 

////////////////////////////////////////////////////////////////////////
//	Name File		  : SaveAndLoad.cpp  				    											//
//	Autor					: Iosif Karshenboim																	//
//	      				: www.iosifk.narod.ru																//
//	Description		: JTAG soft tool                    								//
//	Start design	: 23.08.2006																				//
//	Last revision	: 23.08.2006																				//
////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
// SaveAndLoad.cpp:     
//-----------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#include <inifiles.hpp>
#pragma hdrstop
#include "MyStrings.h"
#include "SaveAndLoad.h"
#include "Unit1.h"

//extern TEdit *RegEditArray[16];
void LoadMyGrid (void);
void LoadStringGrid (TStringGrid *pStringGrid, char cDelimeter, TStringList  *pFileList, int DefColCount, int DefRowCount);
void SaveStringGrid (TStringGrid *pStringGrid, String FileName);

//---------------------------------------------------------------------------
void LoadIni (void)
{
   TIniFile *ini;
   ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
   Form1->Top     =  ini->ReadInteger( "Form1", "Top", 60 );
   Form1->Left    =  ini->ReadInteger( "Form1", "Left", 100 );
   Form1->Width  =  ini->ReadInteger( "Form1", "Width", 557 );
   Form1->Height =  ini->ReadInteger( "Form1", "Height", 381 );
   ini->ReadBool( "Form1", "InitMax", false ) ? Form1->WindowState == wsMaximized : Form1->WindowState == wsNormal;
                                                                             
   Form1->ComboBox3->ItemIndex = ini->ReadInteger("MonitorLevel", "MonitorLevel", 4);
   delete ini;
}
//---------------------------------------------------------------------------

void SaveIni (void)
{
	 TIniFile *ini;
   ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
   //------------------
   ini->WriteInteger( "Form1", "Top", Form1->Top );
   ini->WriteInteger( "Form1", "Left", Form1->Left );
   ini->WriteInteger( "Form1", "Width",  Form1->Width );
   ini->WriteInteger( "Form1", "Height", Form1->Height );
   ini->WriteBool   ( "Form1", "InitMax", Form1->WindowState == wsMaximized );

	 ini->WriteInteger( "MonitorLevel", "MonitorLevel", Form1->ComboBox3->ItemIndex );
	 delete ini;

}
//---------------------------------------------------------------------------
void SavePortParams (void)
{
	 TIniFile *ini;
   ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );

   CableTypes ();

  String strItemNumber;
	ini->WriteString ( "CableTypes", "Name", Form1->ComboBox1->Text);
  ini->WriteInteger( "CableTypes", "CablesNumber", Form1->ComboBox1->Items->Count);

  for(int i=0; i<Form1->ComboBox1->Items->Count; i++)
   {
    strItemNumber = "Item" + IntToStr(i+1);
    ini->WriteString ( "CableTypes", strItemNumber, Form1->ComboBox1->Items->Strings[i]);
    }

 String strCurrCableName = Form1->ComboBox1->Text;
 
 //  String strCableName = RegEditArray[0]->Text;
	if(Form1->RadioButton2->Checked==true)
	 { //      
    ini->WriteString ( strCurrCableName, "Name",                                Form1->ComboBox1->Text);
	  ini->WriteString ( strCurrCableName, "TDO_MASK",     BitStringByte(StrToInt(Form1->Edit3->Text), 8)); 
	  ini->WriteString ( strCurrCableName, "TRST_MASK",    BitStringByte(StrToInt(Form1->Edit4->Text), 8)); 
	  ini->WriteString ( strCurrCableName, "TMS_MASK",     BitStringByte(StrToInt(Form1->Edit5->Text), 8)); 
	  ini->WriteString ( strCurrCableName, "TCK_MASK",     BitStringByte(StrToInt(Form1->Edit6->Text), 8)); 
	  ini->WriteString ( strCurrCableName, "TDI_MASK",     BitStringByte(StrToInt(Form1->Edit7->Text), 8)); 
	  ini->WriteString ( strCurrCableName, "SRST_MASK",    BitStringByte(StrToInt(Form1->Edit8->Text), 8)); 
	  ini->WriteString ( strCurrCableName, "OUTPUT_INVERT",BitStringByte(StrToInt(Form1->Edit9->Text), 8)); 
	  ini->WriteString ( strCurrCableName, "INPUT_INVERT", BitStringByte(StrToInt(Form1->Edit10->Text), 8));
 	  ini->WriteString ( strCurrCableName, "PORT_INIT",    BitStringByte(StrToInt(Form1->Edit11->Text), 8));
 	  ini->WriteString ( strCurrCableName, "VCC_SENSE",    BitStringByte(StrToInt(Form1->Edit12->Text), 8));
 	  ini->WriteString ( strCurrCableName, "PROG_MASK",    BitStringByte(StrToInt(Form1->Edit13->Text), 8));
 	  ini->WriteString ( strCurrCableName, "CTRL_MASK",    BitStringByte(StrToInt(Form1->Edit14->Text), 8));
 	  ini->WriteString ( strCurrCableName, "D6_MASK",      BitStringByte(StrToInt(Form1->Edit15->Text), 8));
 	  ini->WriteString ( strCurrCableName, "BUSY_MASK",    BitStringByte(StrToInt(Form1->Edit16->Text), 8));
 	  ini->WriteString ( strCurrCableName, "PE_MASK",			 BitStringByte(StrToInt(Form1->Edit17->Text), 8));
	 }
	 else
	 { //     
    ini->WriteString ( strCurrCableName, "Name",         Form1->ComboBox1->Text);
	  ini->WriteString ( strCurrCableName, "TDO_MASK",     Form1->Edit3->Text); 
	  ini->WriteString ( strCurrCableName, "TRST_MASK",    Form1->Edit4->Text); 
	  ini->WriteString ( strCurrCableName, "TMS_MASK",     Form1->Edit5->Text); 
	  ini->WriteString ( strCurrCableName, "TCK_MASK",     Form1->Edit6->Text); 
	  ini->WriteString ( strCurrCableName, "TDI_MASK",     Form1->Edit7->Text); 
	  ini->WriteString ( strCurrCableName, "SRST_MASK",    Form1->Edit8->Text); 
	  ini->WriteString ( strCurrCableName, "OUTPUT_INVERT",Form1->Edit9->Text); 
	  ini->WriteString ( strCurrCableName, "INPUT_INVERT", Form1->Edit10->Text);
 	  ini->WriteString ( strCurrCableName, "PORT_INIT",    Form1->Edit11->Text);
 	  ini->WriteString ( strCurrCableName, "VCC_SENSE",    Form1->Edit12->Text);
 	  ini->WriteString ( strCurrCableName, "PROG_MASK",    Form1->Edit13->Text);
 	  ini->WriteString ( strCurrCableName, "CTRL_MASK",    Form1->Edit14->Text);
 	  ini->WriteString ( strCurrCableName, "D6_MASK",      Form1->Edit15->Text);
 	  ini->WriteString ( strCurrCableName, "BUSY_MASK",    Form1->Edit16->Text);
 	  ini->WriteString ( strCurrCableName, "PE_MASK",			 Form1->Edit17->Text);
	  }

	 delete ini;
}
//---------------------------------------------------------------------------
void LoadPortParams (void)
{

 TIniFile *ini;
 ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );

 String strCurrCableName = ini->ReadString ( "CableTypes", "Name", "Curr_cable");
 Form1->ComboBox1->Text  = strCurrCableName;

 int Tmp = ini->ReadInteger( "CableTypes", "CablesNumber", 0);
  String strItemNumber, strNewString;
  Form1->ComboBox1->Items->Clear();
//  delete Form1->ComboBox1->Items;
	for (int i = 0; i < Tmp; i++)
   {
    strItemNumber = "Item" + IntToStr(i+1);
    strNewString = ini->ReadString ( "CableTypes", strItemNumber, "");
    Form1->ComboBox1->Items->Add(strNewString);
  }
  
	LoadAnyPortParams (strCurrCableName);

	delete ini;

}
//---------------------------------------------------------------------------
void LoadOtherPortParams (void)
{
 TIniFile *ini;
 ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );

 String strCurrCableName = Form1->ComboBox1->Text ;
  
 LoadAnyPortParams (strCurrCableName);

	delete ini;
}
//---------------------------------------------------------------------------
void LoadAnyPortParams (String strCableName)
{
	 TIniFile *ini;
   ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );


	if(Form1->RadioButton2->Checked==true)
	 { //      
		Form1->Edit2->Text  =                    ini->ReadString ( strCableName, "Name",         "Curr_cable");
	  Form1->Edit3->Text  = "0x" + IntToHex(BitStringByteToHex(ini->ReadString ( strCableName, "TDO_MASK",     "00000000" )), 2);
	  Form1->Edit4->Text  = "0x" + IntToHex(BitStringByteToHex(ini->ReadString ( strCableName, "TRST_MASK",    "00000000" )), 2);
	  Form1->Edit5->Text  = "0x" + IntToHex(BitStringByteToHex(ini->ReadString ( strCableName, "TMS_MASK",     "00000000" )), 2);
	  Form1->Edit6->Text  = "0x" + IntToHex(BitStringByteToHex(ini->ReadString ( strCableName, "TCK_MASK",     "00000000" )), 2);
	  Form1->Edit7->Text  = "0x" + IntToHex(BitStringByteToHex(ini->ReadString ( strCableName, "TDI_MASK",     "00000000" )), 2);
	  Form1->Edit8->Text  = "0x" + IntToHex(BitStringByteToHex(ini->ReadString ( strCableName, "SRST_MASK",    "00000000" )), 2);
	  Form1->Edit9->Text  = "0x" + IntToHex(BitStringByteToHex(ini->ReadString ( strCableName, "OUTPUT_INVERT","00000000" )), 2);
	  Form1->Edit10->Text = "0x" + IntToHex(BitStringByteToHex(ini->ReadString ( strCableName, "INPUT_INVERT", "00000000" )), 2);
 	  Form1->Edit11->Text = "0x" + IntToHex(BitStringByteToHex(ini->ReadString ( strCableName, "PORT_INIT",    "00000000" )), 2);
 	  Form1->Edit12->Text = "0x" + IntToHex(BitStringByteToHex(ini->ReadString ( strCableName, "VCC_SENSE",    "00000000" )), 2);
 	  Form1->Edit13->Text = "0x" + IntToHex(BitStringByteToHex(ini->ReadString ( strCableName, "PROG_MASK",    "00000000" )), 2);
 	  Form1->Edit14->Text = "0x" + IntToHex(BitStringByteToHex(ini->ReadString ( strCableName, "CTRL_MASK",    "00000000" )), 2);
 	  Form1->Edit15->Text = "0x" + IntToHex(BitStringByteToHex(ini->ReadString ( strCableName, "D6_MASK",      "00000000" )), 2);
 	  Form1->Edit16->Text = "0x" + IntToHex(BitStringByteToHex(ini->ReadString ( strCableName, "BUSY_MASK",    "00000000" )), 2);
 	  Form1->Edit17->Text = "0x" + IntToHex(BitStringByteToHex(ini->ReadString ( strCableName, "PE_MASK",			 "00000000" )), 2);
	 }
	 else
	 { //     
		Form1->Edit2->Text  = ini->ReadString ( strCableName, "Name",         "Curr_cable");
	  Form1->Edit3->Text  = ini->ReadString ( strCableName, "TDO_MASK",     "00000000" );
	  Form1->Edit4->Text  = ini->ReadString ( strCableName, "TRST_MASK",    "00000000" );
	  Form1->Edit5->Text  = ini->ReadString ( strCableName, "TMS_MASK",     "00000000" );
	  Form1->Edit6->Text  = ini->ReadString ( strCableName, "TCK_MASK",     "00000000" );
	  Form1->Edit7->Text  = ini->ReadString ( strCableName, "TDI_MASK",     "00000000" );
	  Form1->Edit8->Text  = ini->ReadString ( strCableName, "SRST_MASK",    "00000000" );
	  Form1->Edit9->Text  = ini->ReadString ( strCableName, "OUTPUT_INVERT","00000000" );
	  Form1->Edit10->Text = ini->ReadString ( strCableName, "INPUT_INVERT", "00000000" );
 	  Form1->Edit11->Text = ini->ReadString ( strCableName, "PORT_INIT",    "00000000" );
 	  Form1->Edit12->Text = ini->ReadString ( strCableName, "VCC_SENSE",    "00000000" );
 	  Form1->Edit13->Text = ini->ReadString ( strCableName, "PROG_MASK",    "00000000" );
 	  Form1->Edit14->Text = ini->ReadString ( strCableName, "CTRL_MASK",    "00000000" );
 	  Form1->Edit15->Text = ini->ReadString ( strCableName, "D6_MASK",      "00000000" );
 	  Form1->Edit16->Text = ini->ReadString ( strCableName, "BUSY_MASK",    "00000000" );
 	  Form1->Edit17->Text = ini->ReadString ( strCableName, "PE_MASK",			"00000000" );
	  }


	Form1->Edit18->Text = ini->ReadString ( "BSDL_params", "file name",                       "");
	Form1->Edit27->Text = ini->ReadString ( "BSDL_params", "ChipName",                       "");
	Form1->Edit26->Text = ini->ReadString ( "BSDL_params", "INSTRUCTION_LENGTH",             "0"); 
	Form1->Edit19->Text = ini->ReadString ( "BSDL_params", "BYPASS",                         "0"); 
	Form1->Edit20->Text = ini->ReadString ( "BSDL_params", "IDCODE",                         "0"); 
	Form1->Edit21->Text = ini->ReadString ( "BSDL_params", "USERCODE",                       "0"); 
	Form1->Edit22->Text = ini->ReadString ( "BSDL_params", "INSTRUCTION CAPTURE",            "0"); 
	Form1->Edit23->Text = ini->ReadString ( "BSDL_params", "32-bit ID",                      "0");
 	Form1->Edit29->Text = ini->ReadString ( "BSDL_params", "USER1",                          "0");
 	Form1->Edit30->Text = ini->ReadString ( "BSDL_params", "USER2",                          "0");
 	Form1->Edit31->Text = ini->ReadString ( "BSDL_params", "USER3",                          "0");
 	Form1->Edit32->Text = ini->ReadString ( "BSDL_params", "USER4",                          "0");
	delete ini;

}
//---------------------------------------------------------------------------
void SaveBSDL (void)
{
	 TIniFile *ini;
   ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );

    //     
    ini->WriteString ( "BSDL_params", "file name",                       Form1->Edit18->Text);
		ini->WriteString ( "BSDL_params", "ChipName",                        Form1->Edit27->Text);
	  ini->WriteString ( "BSDL_params", "INSTRUCTION_LENGTH",              Form1->Edit26->Text); 
	  ini->WriteString ( "BSDL_params", "BYPASS",                          Form1->Edit19->Text); 
	  ini->WriteString ( "BSDL_params", "IDCODE",                          Form1->Edit20->Text); 
	  ini->WriteString ( "BSDL_params", "USERCODE",                        Form1->Edit21->Text); 
	  ini->WriteString ( "BSDL_params", "INSTRUCTION CAPTURE",             Form1->Edit22->Text); 
	  ini->WriteString ( "BSDL_params", "32-bit ID",                       Form1->Edit23->Text);
 	  ini->WriteString ( "BSDL_params", "USER1",                           Form1->Edit29->Text);
 	  ini->WriteString ( "BSDL_params", "USER2",                           Form1->Edit30->Text);
 	  ini->WriteString ( "BSDL_params", "USER3",                           Form1->Edit31->Text);
 	  ini->WriteString ( "BSDL_params", "USER4",                           Form1->Edit32->Text);

	 delete ini;
}
//---------------------------------------------------------------------------
void CableTypes (void)
{
    if(Form1->ComboBox1->Text != Form1->Edit2->Text)
      {
       Form1->ComboBox1->Text = Form1->Edit2->Text;
       Form1->ComboBox1->Items->Insert(0, Form1->ComboBox1->Text);
//       if(Form1->ComboBox1->Items->Count>4)
//        Form1->ComboBox1->Items->Delete(4);
       }

}
//---------------------------------------------------------------------------
void LoadMyGrid (void)
{
	if (Form1->OpenDialog1->Execute())
	{
   //  
   TStringList  *pFileList = new TStringList;
   pFileList->LoadFromFile(Form1->OpenDialog1->FileName.c_str());

   LoadStringGrid (Form1->StringGrid1,   //  TStringGrid *pStringGrid
                     ';',                  // char cDelimeter
                     pFileList,            // TStringList *pFileList
                     9,                    // int DefColCount
                     pFileList->Count);    // int DefRowCount

   pFileList->Clear();
   //----
   String strFileName = Form1->OpenDialog1->FileName;
   //-------------------------------
   //  Table width
    String strTblName =  strFileName.SubString(1, (strFileName.Length())-4) + "_tblw.txt";
   //------------------------------
   int MyColCnt;

   if(FileExists(strTblName.c_str()))
    { //  1  
     pFileList->LoadFromFile(strTblName.c_str());

     // ,  ,     MyColCnt
     ((pFileList->Count)<(Form1->StringGrid1->ColCount)) ? (MyColCnt = pFileList->Count) : (MyColCnt = Form1->StringGrid1->ColCount);

     for (int J = 0; J <MyColCnt; J++)
      Form1->StringGrid1->ColWidths[J]= StrToInt(Trim(pFileList->Strings[J]));
    }
   else
    {
      Application->MessageBox("File for TestTable-Width does not exist!!!", "Hmmm", MB_OK);
      for (int J = 0; J <Form1->StringGrid1->ColCount; J++)
       Form1->StringGrid1->ColWidths[J]= 100;
     }
   //--------------
     pFileList->Clear();
     delete pFileList;
  //----------------------------------------------------
   }
}
//---------------------------------------------------------------------------
void LoadStringGrid (TStringGrid *pStringGrid, char cDelimeter, TStringList  *pFileList, int DefColCount, int DefRowCount)
{
  for (int J = 1; J < pStringGrid->RowCount; J++)
   pStringGrid->Rows[J]->Clear();

 pStringGrid->ColCount=DefColCount;
 pStringGrid->RowCount=DefRowCount;
//-------------------------------
//      FileList->Strings[ !!! ];
//-------------------------------

  //    .
  for(int items_cnt=1; items_cnt < pFileList->Count; items_cnt++)                    //   Pin Table = 8
   {//---------------------------------------------------
    //    
String    row_string = pFileList->Strings[items_cnt];
int       col_cnt = 0;
String    sell_string = "";
    char *ch = row_string.c_str();
      //---------------------------------------
      //  ""   
      //---------------------------------------
      //    row_string
      for(unsigned int j=0; j <  StrLen(row_string.c_str()); j++)
        { if (ch[j] != cDelimeter)                                  // ';'
            {
             if (ch[j] != '"') sell_string += ch[j];  //      sell_string
             if ((j+1) == StrLen(row_string.c_str()))
              {
              pStringGrid->Cells[col_cnt][items_cnt] = sell_string;
              sell_string = "";
              }
             }
          else    //       
            {//      
             if (items_cnt == 0) //    
              { //      
                pStringGrid->Cells[col_cnt][items_cnt] = sell_string;
                sell_string = "";
             //  (pStringGrid->ColCount)++;       
               }
              else  //   
              { 
                  pStringGrid->Cells[col_cnt][items_cnt] = sell_string;
                  sell_string = "";
                  col_cnt ++;
               }
             }             
         }
    //---------------------------------------------------
    }
}
//---------------------------------------------------------------------------
//     
void SaveStringGrid (TStringGrid *pStringGrid, String FileName)
{
  TStringList  *SaveFileList = new TStringList;
  String AsString="";

 for (int J = 0; J < pStringGrid->RowCount; J++)
  {
  // AsString=(IntToStr(J) + " ->");    for test
   AsString=("");
   for (int I = 0; I < pStringGrid->ColCount; I++)
    {
      AsString += pStringGrid->Cells[I][J]; //Puts Text into Buffer

      if (I+1 < pStringGrid->ColCount)
      AsString += ";";
     }
     SaveFileList->Add(AsString);
   }
   // writing to RichEdit1
   /*
   for( int i=0; i <SaveFileList->Count; i++)
   {
    ImportForm->RichEdit1->Lines->Add(SaveFileList->Strings[i]);
    }    */
   // writing to file
   String strFullFileName, strTblName;
   if(FileName.Pos('.') == NULL)
    {
     strFullFileName = FileName + ".csv";
     strTblName =  FileName + "_tblw.txt";
     }
   else
    {
     strFullFileName = FileName.SubString(1, (FileName.Pos('.'))-1) + ".csv";
     strTblName =  FileName.SubString(1, (FileName.Pos('.'))-1) + "_tblw.txt";
     }

   if(FileExists(strFullFileName.c_str()))
    {
     if (MessageDlg("The file for Grid with such name exists!  to replace?", mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes)
      SaveFileList-> SaveToFile(strFullFileName.c_str());
    }
   else
     SaveFileList-> SaveToFile(strFullFileName.c_str());

    //-------------------------------
    SaveFileList->Clear();

    for (int J = 0; J < Form1->StringGrid1->ColCount+1; J++)
    {
     SaveFileList->Add(IntToStr(Form1->StringGrid1->ColWidths[J]));
     }
     SaveFileList-> SaveToFile(strTblName.c_str());
     SaveFileList->Clear(); 

   delete (SaveFileList);
}
//---------------------------------------------------------------------------

