/* ***********************************************************************  
  FREE IP GENERAL PUBLIC LICENSE
  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION

  1.  You may copy and distribute verbatim copies of this core, as long
      as this file, and the other associated files, remain intact and
      unmodified.  Modifications are outlined below.  
  2.  You may use this core in any way, be it academic, commercial, or
      military.  Modified or not.  
  3.  Distribution of this file must be free of charge.  Charging is
      allowed only for value added services.  Value added services
      would include copying fees, modifications, customizations, and
      inclusion in other products.
  4.  If a modified source code is distributed, the original unmodified
      source code must also be included (or a link to my web
      site).  In the modified source code there must be clear
      identification of the modified version.
  5.  Visit the my web site for additional information.
      http://www.iosifk.narod.ru

*********************************************************************** */ 

////////////////////////////////////////////////////////////////////////
//	Name File		  : TAP.cpp  				            											//
//	Autor					: Iosif Karshenboim																	//
//	      				: www.iosifk.narod.ru																//
//	Description		: JTAG soft tool                    								//
//	Start design	: 23.08.2006																				//
//	Last revision	: 23.08.2006																				//
////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
// TAP.cpp:      .
//-----------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>

#pragma hdrstop
#include "MyParPort.h"
#include "MyCable.h"
#include "CableTAP.h"
#include "Unit1.h"



//---------------------------------------------------------------------------

MyTAP::MyTAP()
{
//  
 CableT = new CableTAP();

}
//---------------------------------------------------------------------------

MyTAP::~MyTAP()
{
 //  
// delete PPort();
}
//---------------------------------------------------------------------------
void MyTAP::TAPSetParamsSetParams(String strNewName,
                          char tdo, char trst, char tms, char tck,
                          char tdi, char srst, char o_inv, char i_inv,
                          char init, char vcc_sense, char prog,
													char ctrl, char d6, char busy, char pe)

{ // 
  CableT->MyCableSetParams(strNewName, tdo, trst, tms, tck, tdi, srst, o_inv,
                           i_inv, init, vcc_sense, prog, ctrl, d6, busy, pe);
}
//---------------------------------------------------------------------------
 bool MyTAP::TAPInit(char tdo, char trst, char tms, char tdi, char srst,char tck)
{
  bool bOK=true;
	// 
  bool cTmp = CableT->CableTAPInit(tdo, trst, tms, tdi, srst, tck);

  if(!cTmp)
   bOK = false;
  return (bOK);
}
//---------------------------------------------------------------------------
String MyTAP::ShowTAPName(void)
{
 String strTmp = CableT->ShowMyCableName(); return(strTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPTDO_MASK(void)
{
 char cTmp = CableT->ShowMyCableTDO_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPTRST_MASK(void)
{
 char cTmp = CableT->ShowMyCableTRST_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPTMS_MASK(void)
{
 char cTmp = CableT->ShowMyCableTMS_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPTCK_MASK(void)
{
 char cTmp = CableT->ShowMyCableTCK_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPTDI_MASK(void)
{
 char cTmp = CableT->ShowMyCableTDI_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPSRST_MASK(void)
{
 char cTmp = CableT->ShowMyCableSRST_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPOUTPUT_INVERT(void)
{
 char cTmp = CableT->ShowMyCableOUTPUT_INVERT(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPINPUT_INVERT(void)
{
 char cTmp = CableT->ShowMyCableINPUT_INVERT(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPPORT_INIT(void)
{
 char cTmp = CableT->ShowMyCablePORT_INIT();  return(cTmp);
}
//---------------------------------------------------------------------------
 String MyTAP::ShowTAP_AllParams(void)
{
 String strTmp =
 "cable->name - "            + CableT->ShowCableTAPName() + "\n" +
 "cable->TDO_MASK      - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPTDO_MASK()), 2     ) + "\n" +
 "cable->TRST_MASK     - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPTRST_MASK()), 2    ) + "\n" +
 "cable->TMS_MASK      - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPTMS_MASK()), 2     ) + "\n" +
 "cable->TCK_MASK      - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPTCK_MASK()), 2     ) + "\n" +
 "cable->TDI_MASK      - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPTDI_MASK()), 2     ) + "\n" +
 "cable->SRST_MASK     - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPSRST_MASK()), 2    ) + "\n" +
 "cable->OUTPUT_INVERT - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPOUTPUT_INVERT()), 2) + "\n" +
 "cable->INPUT_INVERT  - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPINPUT_INVERT()), 2 ) + "\n" +
 "cable->PORT_INIT     - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPPORT_INIT()), 2    ) + "\n" +

 "cable->VCC_SENSE     - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPVCC_SENSE()), 2    ) + "\n" +
 "cable->PROG_MASK     - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPPROG_MASK()), 2    ) + "\n" +
 "cable->CTRL_MASK     - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPCTRL_MASK()), 2    ) + "\n" +
 "cable->D6_MASK       - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPD6_MASK()), 2      ) + "\n" +
 "cable->BUSY_MASK     - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPBUSY_MASK()), 2    ) + "\n" +
 "cable->PE_MASK       - 0x" + IntToHex(0xFF&(CableT->ShowCableTAPPE_MASK()), 2      ) + "\n";


 return(strTmp);
}
//---------------------------------------------------------------------------
//--  
//---------------------------------------------------------------------------
char MyTAP::ShowTAPPVCC_SENSE(void)
{
 char cTmp = CableT->ShowCableTAPVCC_SENSE(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPPROG_MASK(void)
{
 char cTmp = CableT->ShowCableTAPPROG_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPCTRL_MASK(void)
{
 char cTmp = CableT->ShowCableTAPCTRL_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPD6_MASK(void)
{
 char cTmp = CableT->ShowCableTAPD6_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPBUSY_MASK(void)
{
 char cTmp = CableT->ShowCableTAPBUSY_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::ShowTAPPE_MASK(void)
{
 char cTmp = CableT->ShowCableTAPPE_MASK(); return(cTmp);
}
//---------------------------------------------------------------------------

//   
char MyTAP::GetTdoData(void)
{
 char cTmp = CableT->GetTdoData(); return(cTmp);
}
//---------------------------------------------------------------------------
bool MyTAP::CheckPower(void)
{
 char cTmp = CableT->CheckPower(); return(cTmp);
}
//---------------------------------------------------------------------------
bool MyTAP::CheckHW(void)
{
 char cTmp = CableT->CheckHW(); return(cTmp);
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
char MyTAP::ShowDataportValue(void)
{
 char cTmp = CableT->ShowDataportValue();
 return(cTmp);
}
//---------------------------------------------------------------------------
char MyTAP::GetDataportValue(void)
{
 char cTmp = CableT->GetDataportValue();
 return(cTmp);
}

//---------------------------------------------------------------------------
//  tms  tdi   N - ,  
//---------------------------------------------------------------------------

void MyTAP::WriteTMS_SetTDI(char tms, char tdi, char N)
{
 	char tms_scan = tms;
 	char tdi_scan = tdi;
 
 for (char i=0; i<N; i++)
 {
  CableT->SetTMS (tms_scan & 1);
  CableT->SetTMS (tdi_scan & 1);
  CableT->UpdatePortDataCLK();

	tms_scan >> 1;
 	tdi_scan >> 1;
  }
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//  tms  tdi   
//     
// N - ,  
//---------------------------------------------------------------------------

String MyTAP::RdWriteTMS_SetTDI(char tms, char tdi, char N)
{
 	char tms_scan = tms;
 	char tdi_scan = tdi;
	String strScanIn = "";
 
 for (char i=0; i<N; i++)
 {
  CableT->SetTMS (tms_scan & 1);
  CableT->SetTMS (tdi_scan & 1);
  CableT->UpdatePortDataCLK();
 
	//    
  strScanIn = IntToStr(Cable-> ???????????????????????????) + strScanIn;

	tms_scan >> 1;
 	tdi_scan >> 1;
  }
	return (strScanIn);
}
//---------------------------------------------------------------------------


/*

typedef struct tap_transition_s
{
	enum tap_state high;
	enum tap_state low;
} tap_transition_t;

extern char* tap_state_strings[16];
extern int tap_move_map[16];	//* map 16 TAP states to 6 stable states *
extern u8 tap_move[6][6];		//* value scanned to TMS to move from one of six stable states to another *
extern tap_transition_t tap_transitions[16];	//* describe the TAP state diagram *

extern enum tap_state end_state;		//* finish DR scans in dr_end_state *
extern enum tap_state cur_state;		//* current TAP state *
*/
//---------------------------------------------------------------------------
/* Tap States
 * TLR - Test-Logic-Reset, RTI - Run-Test/Idle, 
 * SDS - Select-DR-Scan, CD - Capture-DR, SD - Shift-DR, E1D - Exit1-DR,
 * PD - Pause-DR, E2D - Exit2-DR, UD - Update-DR,
 * SIS - Select-IR-Scan, CI - Capture-IR, SI - Shift-IR, E1I - Exit1-IR,
 * PI - Pause-IR, E2I - Exit2-IR, UI - Update-IR 
 */
/*
enum tap_state
{// Tap States
	TAP_TLR = 0x0,			//  0, 		 TLR - Test-Logic-Reset
	TAP_SDS = 0x1,			//	-1,		 SDS - Select-DR-Scan 
	TAP_CD  = 0x2,			//	-1,    CD - Capture-DR 
	TAP_SD  = 0x3,			//	2,     SD - Shift-DR 
	TAP_E1D = 0x4,			//	-1,		 E1D - Exit1-DR 
	TAP_PD  = 0x5,			//	3,     PD - Pause-DR 
	TAP_E2D = 0x6,			//	-1,		 E2D - Exit2-DR 
	TAP_UD  = 0x7,			//	-1,    UD - Update-DR
	TAP_RTI = 0x8,			//	1, 		 RTI - Run-Test/Idle
	TAP_SIS = 0x9,			//	-1,		 SIS - Select-IR-Scan 
	TAP_CI  = 0xa,			//	-1,    CI - Capture-IR 
	TAP_SI  = 0xb,			//	4,     SI - Shift-IR 
	TAP_E1I = 0xc,			//	-1,		 E1I - Exit1-IR
	TAP_PI  = 0xd,			//	5,     PI - Pause-IR 
	TAP_E2I = 0xe,			//	-1,		 E2I - Exit2-IR 
	TAP_UI  = 0xf			  //	-1     UI - Update-IR
};
enum tap_state end_state = TAP_TLR;
enum tap_state cur_state = TAP_TLR;

char* tap_state_strings[16] =
{
	"tlr", 
	"sds", "cd", "sd", "e1d", "pd", "e2d", "ud",
	"rti",
	"sis", "ci", "si", "e1i", "pi", "e2i", "ui"
};
*/
/*
tap_transition_t tap_transitions[16] =
{
	{TAP_TLR, TAP_RTI},		// TLR //
	{TAP_SIS, TAP_CD},		// SDS //
	{TAP_E1D, TAP_SD},		// CD  //
	{TAP_E1D, TAP_SD},		// SD  //
	{TAP_UD,  TAP_PD}, 		// E1D //
	{TAP_E2D, TAP_PD},		// PD  //
	{TAP_UD,  TAP_SD},		// E2D //
	{TAP_SDS, TAP_RTI},		// UD  //
	{TAP_SDS, TAP_RTI},		// RTI //
	{TAP_TLR, TAP_CI},		// SIS //
	{TAP_E1I, TAP_SI},		// CI  //
	{TAP_E1I, TAP_SI},		// SI  //
	{TAP_UI,  TAP_PI}, 		// E1I //
	{TAP_E2I, TAP_PI},		// PI  //
	{TAP_UI,  TAP_SI},		// E2I //
	{TAP_SDS, TAP_RTI}		// UI  //
};
*/


//---------------------------------------------------------------------------
//      TAP  ...
//  16    5 !!!
//---------------------------------------------------------------------------

int tap_move_map[16] = {
	0, -1, -1,  2, -1,  3, -1, -1,
	1, -1, -1,  4, -1,  5, -1, -1
};

// tap_move[i][j]: tap movement command to go from state i to state j
// 0: Test-Logic-Reset
// 1: Run-Test/Idle
// 2: Shift-DR
// 3: Pause-DR
// 4: Shift-IR
// 5: Pause-IR

char amt_jtagaccel_tap_move[6][6][2] =
{
	/*	   TLR           RTI              SD            PD            SI            PI             */
	{{0x1f, 0x00}, {0x0f, 0x00}, {0x8a, 0x04}, {0x0a, 0x00}, {0x06, 0x00}, {0x96, 0x00}},	/* TLR */
	{{0x1f, 0x00}, {0x00, 0x00}, {0x85, 0x08}, {0x05, 0x00}, {0x8b, 0x08}, {0x0b, 0x00}},	/* RTI */
	{{0x1f, 0x00}, {0x0d, 0x00}, {0x00, 0x00}, {0x01, 0x00}, {0x8f, 0x09}, {0x8f, 0x01}},	/* SD  */
	{{0x1f, 0x00}, {0x0c, 0x00}, {0x08, 0x00}, {0x00, 0x00}, {0x8f, 0x09}, {0x8f, 0x01}},	/* PD  */
	{{0x1f, 0x00}, {0x0d, 0x00}, {0x07, 0x00}, {0x97, 0x00}, {0x00, 0x00}, {0x01, 0x00}},	/* SI  */
	{{0x1f, 0x00}, {0x0c, 0x00}, {0x07, 0x00}, {0x97, 0x00}, {0x08, 0x00}, {0x00, 0x00}},	/* PI  */
};

/*
//---------------------------------------------------------------------------
bool bitbang_end_state(int state)
{ 
	bool bOK = true;
	//   ,    
	if (tap_move_map[state] != -1)
		end_state = state;
	else
	{
//		ERROR("BUG: %i is not a valid end state", state);
		ShowMessage("BUG: " +  state + " is not a valid end state");
		bOK = false;
	}
	return(bOK);
}
//---------------------------------------------------------------------------
*/


