/* ***********************************************************************  
  FREE IP GENERAL PUBLIC LICENSE
  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION

  1.  You may copy and distribute verbatim copies of this core, as long
      as this file, and the other associated files, remain intact and
      unmodified.  Modifications are outlined below.  
  2.  You may use this core in any way, be it academic, commercial, or
      military.  Modified or not.  
  3.  Distribution of this file must be free of charge.  Charging is
      allowed only for value added services.  Value added services
      would include copying fees, modifications, customizations, and
      inclusion in other products.
  4.  If a modified source code is distributed, the original unmodified
      source code must also be included (or a link to my web
      site).  In the modified source code there must be clear
      identification of the modified version.
  5.  Visit the my web site for additional information.
      http://www.iosifk.narod.ru

*********************************************************************** */ 

////////////////////////////////////////////////////////////////////////
//	Name File		  : TAP.h    		        		    											//
//	Autor					: Iosif Karshenboim																	//
//	      				: www.iosifk.narod.ru																//
//	Description		: JTAG soft tool                    								//
//	Start design	: 23.08.2006																				//
//	Last revision	: 23.08.2006																				//
////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
// TAP.h: contain headers of TAP functions.
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
#ifndef MyTAP_h
#define MyTAP_h
//-----------------------------------------------------------------------------
CableTAP* CableT; // pointer to instance of MyParPort class to get access to ParPort



class MyTAP {

//  char dataport_value;

 // ,   
// MyCable;
 
public:

  MyTAP();
  ~MyTAP();


 //   
 void MyTAP::SetParams(String strNewName,
                          char tdo, char trst, char tms, char tck,
                          char tdi, char srst, char o_inv, char i_inv,
                          char init, char vcc_sense, char prog,
													char ctrl, char d6, char busy, char pe);

 //  
 void MyTAP::TAPInit(char tdo, char trst, char tms, char tdi, char srst,char tck);
 


 //   
 void MyTAP::SetTRST(char trst)			{CableT->SetTRST(trst);};
 void MyTAP::SetTMS (char tms)				{CableT->SetTMS (tms);};
 void MyTAP::SetTCK (char tck)				{CableT->SetTCK (tck);};
 void MyTAP::SetTDI (char tdi)				{CableT->SetTDI (tdi);};
 void MyTAP::SetSRST(char srst)			{CableT->SetSRST(srst);};

 //--  
//        !!!!
 void MyTAP::SetPROG (char prog)			{CableT->SetPROG (prog);};
 void MyTAP::SetCTRL(char ctrl)			{CableT->SetCTRL(ctrl);};

 //    
// String MyTAP::ShowTAPName(void)				 {return(Cable->ShowMyCableName());};
 String MyTAP::ShowTAPName(void);
 
 char MyTAP::ShowTAPTDO_MASK(void);       
 char MyTAP::ShowTAPTRST_MASK(void);      
 char MyTAP::ShowTAPTMS_MASK(void);       
 char MyTAP::ShowTAPTCK_MASK(void);       
 char MyTAP::ShowTAPTDI_MASK(void);       
 char MyTAP::ShowTAPSRST_MASK(void);      
 char MyTAP::ShowTAPOUTPUT_INVERT(void);  
 char MyTAP::ShowTAPINPUT_INVERT(void);   
 char MyTAP::ShowTAPPORT_INIT(void);

 char MyTAP::ShowTAPVCC_SENSE(void);
 char MyTAP::ShowTAPPROG_MASK(void);
 char MyTAP::ShowTAPCTRL_MASK(void);
 char MyTAP::ShowTAPD6_MASK(void);
 char MyTAP::ShowTAPBUSY_MASK(void);
 char MyTAP::ShowTAPPE_MASK(void);

 //   
 char MyTAP::GetTdoData(void);
 bool MyTAP::CheckPower(void);
 bool MyTAP::CheckHW(void);


 String MyTAP::ShowTAP_AllParams(void);

 char MyTAP::ShowDataportValue(void);  
 char MyTAP::GetDataportValue(void);   
 
 void MyTAP::UpdatePortDataCLK(void)  {CableT->UpdatePortDataCLK();};

 void MyTAP::WriteTMS_SetTDI(char tms, char tdi, char N);
 String MyTAP::RdWriteTMS_SetTDI(char tms, char tdi, char N);
};

//-----------------------------------------------------------------------------
#endif
