/* ***********************************************************************  
  FREE IP GENERAL PUBLIC LICENSE
  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION

  1.  You may copy and distribute verbatim copies of this core, as long
      as this file, and the other associated files, remain intact and
      unmodified.  Modifications are outlined below.  
  2.  You may use this core in any way, be it academic, commercial, or
      military.  Modified or not.  
  3.  Distribution of this file must be free of charge.  Charging is
      allowed only for value added services.  Value added services
      would include copying fees, modifications, customizations, and
      inclusion in other products.
  4.  If a modified source code is distributed, the original unmodified
      source code must also be included (or a link to my web
      site).  In the modified source code there must be clear
      identification of the modified version.
  5.  Visit the my web site for additional information.
      http://www.iosifk.narod.ru

*********************************************************************** */ 

////////////////////////////////////////////////////////////////////////
//	Name File		  : TapFunc.cpp     				    											//
//	Autor					: Iosif Karshenboim																	//
//	      				: www.iosifk.narod.ru																//
//	Description		: JTAG soft tool                    								//
//	Start design	: 23.08.2006																				//
//	Last revision	: 23.08.2006																				//
////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
// TapFunc.cpp: contain Func of LPT-Port.
//-----------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop
#include "Main.h"
#include "IO_Port.h"
#include "TapFunc.h"

HANDLE h;

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
/*
int DP=0x378;           // data port
int SP=0x379;           // status port
int CP=0x37a;           // control port
DATA    PORTADDRESS=0x378
STATUS  PORTADDRESS=0x379
CONTROL PORTADDRESS=0x37a

*/

#define PORTADDRESS 0x378 /* Port Address for Parallel port, 0x378 for LPT1, 0x278 for LPT2 */
#define DATA PORTADDRESS+0
#define STATUS PORTADDRESS+1
#define CONTROL PORTADDRESS+2

//---------------------------------------------------------------------------

TAP::TAP() 
{

	 //*******************************************************
   h = CreateFile("\\\\.\\giveio", GENERIC_READ, 0, NULL,
                  OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
   if (h==INVALID_HANDLE_VALUE)
    {
     MainForm->Memo1->Lines->Add("Error! Unable to open giveio.sys driver!");
     CloseHandle(h);
     }
   //*******************************************************



}
//---------------------------------------------------------------------------

TAP::~TAP() 
{
 CloseHandle(h);  
}
//---------------------------------------------------------------------------
void  TAP::Init(void)          
{

init[0] = 0x38;
init[1] = 0x38;
init[2] = 0x38;         // Init Display


init[3] = 0x08;        // display off
init[4] = 0x01;				 // Clear Display
init[5] = 0x06;        // entry mode set
init[6] = 0x0e;        // display on
init[7] = 0x02;				 // Return Home

outb(CONTROL, 0x09);

for (count = 0; count <= 7; count++)
 {
  outb(DATA, init[count]);										/* write initialization command for LCD Module */
  outb(CONTROL, 0x08); //Strobe E= 1, RS=0/
  Sleep(20);																	/* Larger Delay for INIT */
  outb(CONTROL, 0x09); //Strobe E= 0, RS=0/
	Sleep(20);																	/* Larger Delay for INIT */
}
outb(CONTROL, 0x01);          //Strobe E= 0, RS=1/
}

//---------------------------------------------------------------------------
void  TAP::WrData (char cData)          //
{
 outb(DATA, cData);
 outb(CONTROL, 0x00);          //Strobe E= 1, RS=1/
 Sleep(20);
 outb(CONTROL, 0x01);          //Strobe E= 0, RS=1/
 Sleep(20);
}   
//---------------------------------------------------------------------------
void  TAP::WrControl (char cData)
{
 outb(CONTROL, 0x09);

 outb(DATA, cData);
 outb(CONTROL, 0x08); //Strobe E= 1, RS=0/
 Sleep(20);																	// Larger Delay
 outb(CONTROL, 0x09); //Strobe E= 0, RS=0/
 Sleep(20);																	// Larger Delay

 outb(CONTROL, 0x01);          //Strobe E= 0, RS=1/
}


//-----------------------------------------------------------------------------
void TAP::WriteByteToPort(int PortAddr, char Data)
{
 outb( WORD (PortAddr), Data);
}
//-----------------------------------------------------------------------------
BYTE TAP::ReadByteFromPort(int PortAddr)
{
 WORD Tmp1=PortAddr;
 return (_Inp(Tmp1));
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
LcdSettings::LcdSettings()
{
 for(unsigned int j=0; j <0x68; j++)
   DDRAM[j]=0x20;
}
//---------------------------------------------------------------------------

LcdSettings::~LcdSettings()
{
}
//---------------------------------------------------------------------------
void  LcdSettings::Clear_DDRAM (void)
{
 for(unsigned int j=0; j <0x68; j++)
   DDRAM[j]=0x20;

}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
RunningString::RunningString()
{
 strMyString="";
 MyStringIndex=1;
 MyStringLen=1;
 MyListStringsNumber=1;
 MyListStringsIndex=1;
}
//---------------------------------------------------------------------------

RunningString::~RunningString()
{
}
//---------------------------------------------------------------------------
