/* ***********************************************************************  
  FREE IP GENERAL PUBLIC LICENSE
  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION

  1.  You may copy and distribute verbatim copies of this core, as long
      as this file, and the other associated files, remain intact and
      unmodified.  Modifications are outlined below.  
  2.  You may use this core in any way, be it academic, commercial, or
      military.  Modified or not.  
  3.  Distribution of this file must be free of charge.  Charging is
      allowed only for value added services.  Value added services
      would include copying fees, modifications, customizations, and
      inclusion in other products.
  4.  If a modified source code is distributed, the original unmodified
      source code must also be included (or a link to my web
      site).  In the modified source code there must be clear
      identification of the modified version.
  5.  Visit the my web site for additional information.
      http://www.iosifk.narod.ru

*********************************************************************** */ 

////////////////////////////////////////////////////////////////////////
//	Name File		  : TapFunc.h    		    		    											//
//	Autor					: Iosif Karshenboim																	//
//	      				: www.iosifk.narod.ru																//
//	Description		: JTAG soft tool                    								//
//	Start design	: 23.08.2006																				//
//	Last revision	: 23.08.2006																				//
////////////////////////////////////////////////////////////////////////
//-----------------------------------------------------------------------------
// TapFunc.h: contain headers of TAP functions.
//-----------------------------------------------------------------------------
#include <string>
#include <cstring.h>
#include <dstring.h>

//-----------------------------------------------------------------------------
#ifndef TapFunc_h
#define TapFunc_h
//-----------------------------------------------------------------------------


class TAP {
       	char init[10];
	      int count;

public:

  TAP();
  ~TAP();                          // closes previously opened driver, delete allocated memory

 void  Init(void);
 void WriteByteToPort(int PortAddr, char Data);
 BYTE ReadByteFromPort(int PortAddr);

 void  WrData (char cData);
 void  WrControl (char cData);

};

class LcdSettings {
       	bool bID;
	      bool bSH;
        bool bDL;
        bool bN;
        bool bF;

       	bool bD;
	      bool bC;
        bool bB;
        bool bSC;
        bool bRL;

        int CGRAM_Addr;
        int DDRAM_Addr;
        char DDRAM[0x068];
        int DDRAM_Curr_Addr;
public:

  LcdSettings();
  ~LcdSettings();                          // closes previously opened driver, delete allocated memory

 void  Set_Data_bID (bool bPrm) {bID=bPrm;};
 bool  Get_Data_bID (void)      {return(bID);};

 void  Set_Data_bSH (bool bPrm) {bSH=bPrm;};
 bool  Get_Data_bSH (void)      {return(bSH);};

 void  Set_Data_bDL (bool bPrm) {bDL=bPrm;};
 bool  Get_Data_bDL (void)      {return(bDL);};

 void  Set_Data_bN (bool bPrm)  {bN=bPrm;};
 bool  Get_Data_bN (void)       {return(bN);};

 void  Set_Data_bF (bool bPrm)  {bF=bPrm;};
 bool  Get_Data_bF (void)       {return(bF);};

//-------------
 void  Set_Data_bD (bool bPrm) {bD=bPrm;};
 bool  Get_Data_bD (void)      {return(bD);};

 void  Set_Data_bC (bool bPrm) {bC=bPrm;};
 bool  Get_Data_bC (void)      {return(bC);};

 void  Set_Data_bB (bool bPrm) {bB=bPrm;};
 bool  Get_Data_bB (void)      {return(bB);};

 void  Set_Data_bSC (bool bPrm)  {bSC=bPrm;};
 bool  Get_Data_bSC (void)       {return(bSC);};

 void  Set_Data_bRL (bool bPrm)  {bRL=bPrm;};
 bool  Get_Data_bRL (void)       {return(bRL);};



 void  Set_Data_CGRAM_Addr (int Prm) {CGRAM_Addr=Prm;};
 int   Get_Data_CGRAM_Addr (void)    {return(CGRAM_Addr);};

 void  Set_Data_DDRAM_Addr (int Prm) {DDRAM_Addr=Prm;};
 int   Get_Data_DDRAM_Addr (void)    {return(DDRAM_Addr);};

 void  Set_DDRAM_Curr_Addr (int Prm) {DDRAM_Curr_Addr=Prm;};
 int   Get_DDRAM_Curr_Addr (void)    {return(DDRAM_Curr_Addr);};

 void  Set_DDRAM (int CAddr, char Prm) {DDRAM[CAddr]=Prm;};
 char  Get_DDRAM (int CAddr)           {return(DDRAM[CAddr]);};

 void  Clear_DDRAM (void);

};

//-----------------------------------------------------------------------------

class RunningString {

       String strMyString;
        int MyStringIndex;
        int MyStringLen;
        int MyListStringsNumber;
        int MyListStringsIndex;

public:

 RunningString();
  ~RunningString();                          // closes previously opened driver, delete allocated memory

 void  SetMyString (String strPrm)   {strMyString=strPrm;};
 void  SetMyStringIndex (int Prm) {MyStringIndex=Prm;};
 int   GetMyStringIndex (void)    {return(MyStringIndex);};
 int   GetMyStringLen (void)      {return(strMyString.Length());};
 char  GetChar (void)             {return(strMyString[MyStringIndex]);};

 void  SetMyListStringsNumber (int Prm) {MyListStringsNumber=Prm;};
 int   GetMyListStringsNumber (void)      {return(MyListStringsNumber);};

 void  SetMyListStringsIndex  (int Prm) {MyListStringsIndex =Prm;};
 int   GetMyListStringsIndex (void)      {return(MyListStringsIndex);};



};

//-----------------------------------------------------------------------------
#endif
