/* ***********************************************************************  
  FREE IP GENERAL PUBLIC LICENSE
  TERMS AND CONDITIONS FOR USE, COPYING, DISTRIBUTION, AND MODIFICATION

  1.  You may copy and distribute verbatim copies of this core, as long
      as this file, and the other associated files, remain intact and
      unmodified.  Modifications are outlined below.  
  2.  You may use this core in any way, be it academic, commercial, or
      military.  Modified or not.  
  3.  Distribution of this file must be free of charge.  Charging is
      allowed only for value added services.  Value added services
      would include copying fees, modifications, customizations, and
      inclusion in other products.
  4.  If a modified source code is distributed, the original unmodified
      source code must also be included (or a link to my web
      site).  In the modified source code there must be clear
      identification of the modified version.
  5.  Visit the my web site for additional information.
      http://www.iosifk.narod.ru

*********************************************************************** */ 

////////////////////////////////////////////////////////////////////////
//	Name File		  : Unit1.cpp       				    											//
//	Autor					: Iosif Karshenboim																	//
//	      				: www.iosifk.narod.ru																//
//	Description		: JTAG soft tool                    								//
//	Start design	: 23.08.2006																				//
//	Last revision	: 23.08.2006																				//
////////////////////////////////////////////////////////////////////////
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop 
#include "Unit1.h"
#include "MyParPort.h"
#include "MyCable.h"
#include "CableTAP.h"
#include "MyTAP.h"
#include "SaveAndLoad.h"
#include "MyStrings.h"
#include "OnFormStart.h"
#include "About.h"
#include "MyBSDL.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

extern MyTAP* CableP;
MyCable* PPortCable;
extern TEdit *RegEditArray[16];
String strScanString;
String *pScanString;
int BtnsDone;

void ShowMyCable(MyTAP* CableP, TRichEdit* pRichEdit);
extern bool TapTransition (int next_state);
//extern bool TapTransitionScan (int end_state);

TButton *psg[100];
int MyItemFocused;
int Column, Row;

extern DynamicArray<char> IrScanWrite;   // WRITE DATA BYTE BUFFER
//extern char *pIrScanWrite;
extern DynamicArray<char> IrScanRead;    // READ DATA BYTE BUFFER
extern DynamicArray<char> DrScanWrite;
extern DynamicArray<char> DrScanRead;

extern bool TapIrScan (String strScanStringCommand,
                DynamicArray<char> &IrScanWrite,/*, // WRITE DATA BYTE BUFFER
                DynamicArray<char> &IrScanRead */  // READ DATA BYTE BUFFER
                int TapEndState,
                int MonitorLevel);

extern bool TapDrScan (int DataScanLength,
                DynamicArray<char> &DrScanWrite, // WRITE DATA BYTE BUFFER
                DynamicArray<char> &DrScanRead,  // READ DATA BYTE BUFFER
                int TapEndState,
                int MonitorLevel);
extern String strScanIrStringData, strScanDrStringData;

//   -       
//      WRITE DATA BYTE BUFFER
//     WRITE DATA BYTE BUFFER  READ DATA BYTE BUFFER
extern bool ScanMyData (String strScanStringCommand,     //      
                 int DataBitsScanLength,          //    
                 bool bTwice,
                 DynamicArray<char> &DrScanWrite, // WRITE DATA BYTE BUFFER
                 DynamicArray<char> &DrScanRead,
                 int MonitorLevel); // READ DATA BYTE BUFFER

extern bool GetID (String strScanStringCommand,
                DynamicArray<char> &DrScanWrite, // WRITE DATA BYTE BUFFER
                DynamicArray<char> &DrScanRead,
                int MonitorLevel); // READ DATA BYTE BUFFER

extern int GetChipNumber (int MonitorLevel);
extern void SaveBSDL (void);
extern void LoadMyGrid (void);
extern void SaveStringGrid (TStringGrid *pStringGrid, String FileName);
void MyClickOnGreed (void);
extern bool OneStepInGrid (int MyItemFocused);


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{

   OnFormStart ();
   MyItemFocused = 1;
}
//---------------------------------------------------------------------------


void ShowMyCable(MyTAP* CableP, TRichEdit* pRichEdit)
{
  pRichEdit->Lines->Add("cable->name - "            + CableP->ShowTAPName());
  pRichEdit->Lines->Add("cable->TDO_MASK      - 0x" + IntToHex(0xFF&(CableP->ShowTAPTDO_MASK()), 2     )); // status port bit containing current TDO value
  pRichEdit->Lines->Add("cable->TRST_MASK     - 0x" + IntToHex(0xFF&(CableP->ShowTAPTRST_MASK()), 2    )); // data port bit for TRST
  pRichEdit->Lines->Add("cable->TMS_MASK      - 0x" + IntToHex(0xFF&(CableP->ShowTAPTMS_MASK()), 2     )); // data port bit for TMS
	pRichEdit->Lines->Add("cable->TCK_MASK      - 0x" + IntToHex(0xFF&(CableP->ShowTAPTCK_MASK()), 2     )); // data port bit for TCK
  pRichEdit->Lines->Add("cable->TDI_MASK      - 0x" + IntToHex(0xFF&(CableP->ShowTAPTDI_MASK()), 2     )); // data port bit for TDI
  pRichEdit->Lines->Add("cable->SRST_MASK     - 0x" + IntToHex(0xFF&(CableP->ShowTAPSRST_MASK()), 2    )); // data port bit for SRST
	pRichEdit->Lines->Add("cable->OUTPUT_INVERT - 0x" + IntToHex(0xFF&(CableP->ShowTAPOUTPUT_INVERT()), 2)); // data port bits that should be inverted
  pRichEdit->Lines->Add("cable->INPUT_INVERT  - 0x" + IntToHex(0xFF&(CableP->ShowTAPINPUT_INVERT()), 2 )); // status port that should be inverted
  pRichEdit->Lines->Add("cable->PORT_INIT     - 0x" + IntToHex(0xFF&(CableP->ShowTAPPORT_INIT()), 2    )); // initialize data port with this value
	pRichEdit->Lines->Add("cable->VCC_SENSE     - 0x" + IntToHex(0xFF&(CableP->ShowTAPVCC_SENSE()), 2    )); // data port bit for TCK
  pRichEdit->Lines->Add("cable->PROG_MASK     - 0x" + IntToHex(0xFF&(CableP->ShowTAPPROG_MASK()), 2    )); // data port bit for TDI
  pRichEdit->Lines->Add("cable->CTRL_MASK     - 0x" + IntToHex(0xFF&(CableP->ShowTAPCTRL_MASK()), 2    )); // data port bit for SRST
	pRichEdit->Lines->Add("cable->D6_MASK       - 0x" + IntToHex(0xFF&(CableP->ShowTAPD6_MASK()), 2      )); // data port bits that should be inverted
  pRichEdit->Lines->Add("cable->BUSY_MASK     - 0x" + IntToHex(0xFF&(CableP->ShowTAPBUSY_MASK()), 2    )); // status port that should be inverted
  pRichEdit->Lines->Add("cable->PE_MASK       - 0x" + IntToHex(0xFF&(CableP->ShowTAPPE_MASK()), 2      )); // initialize data port with this value
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
 SavePortParams();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
 OnFormClose();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{
 LoadOtherPortParams();  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
 RichEdit1->Clear();  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
 ShowMyCable(CableP, RichEdit1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
 AboutBox->Show();  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{
 Form1->Edit2->Text = Form1->ComboBox1->Text;
 LoadOtherPortParams();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button11Click(TObject *Sender)
{

 LoadBSDL(1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button12Click(TObject *Sender)
{//   ,     JTAG-
 int Btns = StrToInt(Edit55->Text);

 if(BtnsDone!=0)
 {
  for(int i=0; i<BtnsDone; i++)
   {
    delete psg[i];
    }
 }

 //  
 for(int i=0; i<Btns; i++)
   {
    psg[i] = new TButton(this);
    psg[i]->Parent = Form1->GroupBox9;
		psg[i]->Name = AnsiString("pts") + IntToStr(i);

    SetWindowLong(psg[i]->Handle,GWL_STYLE,GetWindowLong(psg[i]->Handle,GWL_STYLE)|BS_MULTILINE); 
    psg[i]->Caption="Chip "+IntToStr(i) + "\nLoaded - ****\nManuf - ****\nIr Scan - ****\nMy Regs - ***";

	  psg[i]->Align  = alNone;
    psg[i]->Height = 80;
    psg[i]->Width = (Form1->GroupBox9->Width-10)/Btns;
    psg[i]->Top = 20;
    psg[i]->Left = 5 + (psg[i]->Width)*i;
    psg[i]->ShowHint=true;
    psg[i]->Hint="Chip "+IntToStr(i) + "\nLoaded - ****\nManuf - ****\nIr Scan - ****\nMy Regs - ***";

    psg[i]->Tag = i;
    //-----------------------------------------------------------
    psg[i]->OnClick = Form1->Button6Click;
/*
        
 void __fastcall TForm1::Button6Click(TObject *Sender)
      GroupBox9

  ,  psg[i]-  

   for (int i=0;i<(Btns);i++)     //Btns -       
      {if(psg[i]==Sender)
         = IntToStr(psg[i]->Tag);
     }

*/
    }
  BtnsDone = Btns; 
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button13Click(TObject *Sender)
{
 //         ...
 String strBitString = Edit1->Text;

 BitStringToHex(strBitString ,    //  String strBitString
                IrScanWrite);    //  DynamicArray<char> &CharArray

RichEdit1->Lines->Add("************************");
RichEdit1->Lines->Add("strBitString - "  + strBitString);
RichEdit1->Lines->Add("String Length - " + IntToStr(strBitString.Length()));
RichEdit1->Lines->Add("Array Length - "  + IntToStr(IrScanWrite.Length));

 for(int i=0; i<IrScanWrite.Length; i++)
  {
   RichEdit1->Lines->Add("i - " + IntToStr(i) + ", IrScanWrite->Data - 0x" + IntToHex(IrScanWrite[i]& 0xFF, 2));
   }

  //*********************************************************
  TapIrScan (Form1->Edit1->Text,
             IrScanWrite,/*, // WRITE DATA BYTE BUFFER
             IrScanRead*/  // READ DATA BYTE BUFFER
             0,
             Form1->ComboBox3->ItemIndex);
  RichEdit1->Lines->Add("TapIrScan - "  + strScanIrStringData);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button14Click(TObject *Sender)
{
  String strIDCODE;
  if(Form1->Edit27->Text !="")
   {
    strIDCODE = Form1->Edit20->Text;
    Form1->Edit1->Text = Form1->Edit20->Text;

    ShowMessage("Chip - " + Form1->Edit27->Text
             +  " IDCODE - " + strIDCODE);

   GetID (Form1->Edit20->Text,
         DrScanWrite, // WRITE DATA BYTE BUFFER
         DrScanRead,
         Form1->ComboBox3->ItemIndex);  // READ DATA BYTE BUFFER
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button15Click(TObject *Sender)
{
  GetChipNumber(Form1->ComboBox3->ItemIndex);

}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button10Click(TObject *Sender)
{
 SaveBSDL();  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button9Click(TObject *Sender)
{

//  
 PPortCable = new MyCable();
 
	if(Form1->RadioButton2->Checked==true)
	 { //      
      PPortCable->MyCableSetParams( Form1->Edit2->Text,
                     StrToInt(Form1->Edit3->Text),
 										 StrToInt(Form1->Edit4->Text),
 										 StrToInt(Form1->Edit5->Text),
 										 StrToInt(Form1->Edit6->Text),
 										 StrToInt(Form1->Edit7->Text),
 										 StrToInt(Form1->Edit8->Text),
 										 StrToInt(Form1->Edit9->Text),
 										 StrToInt(Form1->Edit10->Text),
 										 StrToInt(Form1->Edit11->Text),
 										 StrToInt(Form1->Edit12->Text),
 										 StrToInt(Form1->Edit13->Text),
 										 StrToInt(Form1->Edit14->Text),
 										 StrToInt(Form1->Edit15->Text),
 										 StrToInt(Form1->Edit16->Text),
 										 StrToInt(Form1->Edit17->Text));	 
	 
	 }
	 else
	 { //      
       PPortCable->MyCableSetParams(               Form1->Edit2->Text,
                     BitStringByteToHex(Form1->Edit3->Text),
 										 BitStringByteToHex(Form1->Edit4->Text),
 										 BitStringByteToHex(Form1->Edit5->Text),
 										 BitStringByteToHex(Form1->Edit6->Text),
 										 BitStringByteToHex(Form1->Edit7->Text),
 										 BitStringByteToHex(Form1->Edit8->Text),
 										 BitStringByteToHex(Form1->Edit9->Text),
				             BitStringByteToHex(Form1->Edit10->Text),
 										 BitStringByteToHex(Form1->Edit11->Text),
 										 BitStringByteToHex(Form1->Edit12->Text),
 										 BitStringByteToHex(Form1->Edit13->Text),
 										 BitStringByteToHex(Form1->Edit14->Text),
 										 BitStringByteToHex(Form1->Edit15->Text),
 										 BitStringByteToHex(Form1->Edit16->Text),
 										 BitStringByteToHex(Form1->Edit17->Text));

    }

// PPortCable->GetPortData();
// ShowMyCable(PPortCable, RichEdit1);
 //   
 PPortCable->SetTRST(StrToInt(Trim(Form1->Edit42->Text)));
 PPortCable->SetTMS (StrToInt(Trim(Form1->Edit36->Text)));
 PPortCable->SetTCK (StrToInt(Trim(Form1->Edit38->Text)));
 PPortCable->SetTDI (StrToInt(Trim(Form1->Edit35->Text)));
 PPortCable->SetSRST(StrToInt(Trim(Form1->Edit43->Text)));

 //--  
//        !!!!
 PPortCable->SetPROG (StrToInt(Trim(Form1->Edit33->Text)));
 PPortCable->SetCTRL(StrToInt(Trim(Form1->Edit37->Text)));
 PPortCable->UpdatePortData();
 delete PPortCable;


 Form1->Edit44->Text = "0x" + IntToHex(CableP->GetTdoData(), 2);
 Form1->Edit45->Text = "0x" + IntToHex(CableP->GetDataportValue(), 2);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button16Click(TObject *Sender)
{
 Form1->Edit44->Text = "0x" + IntToHex(CableP->GetTdoData(), 2);
 Form1->Edit45->Text = "0x" + IntToHex(CableP->GetDataportValue(), 2);

 RichEdit1->Lines->Add("cable->GetDataportValue - 0x" + IntToHex(0xFF&(CableP->GetDataportValue()), 2));

}
//---------------------------------------------------------------------------



void __fastcall TForm1::BitBtn12Click(TObject *Sender)
{
      Form1->StringGrid1->Cells[1][MyItemFocused]=" BP";
      //--------------------------------
      TGridRect myRect;
	    myRect.Left = 1;
      myRect.Top = MyItemFocused;
	    myRect.Right = 1;
	    myRect.Bottom = MyItemFocused;
	    Form1->StringGrid1->Selection = myRect;
      //--------------------------------  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BitBtn13Click(TObject *Sender)
{
      Form1->StringGrid1->Cells[1][MyItemFocused]="";
      //--------------------------------
      TGridRect myRect;
	    myRect.Left = 1;
      myRect.Top = MyItemFocused;
	    myRect.Right = 1;
	    myRect.Bottom = MyItemFocused;
	    Form1->StringGrid1->Selection = myRect;
      //--------------------------------  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BitBtn14Click(TObject *Sender)
{
 for (int J = 1; J < Form1->StringGrid1->RowCount; J++)
    {
    Form1->StringGrid1->Cells[1][J]="";
    }  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button54Click(TObject *Sender)
{
 if(Timer1->Enabled==false)
  {
   Form1->Button54->Caption="Stop";
   Form1->RichEdit1->Lines->Add("Timer Start!!!");
   Timer1->Interval = StrToInt(Form1->ComboBox47->Text);
   Timer1->Enabled=true;
   }
 else
  {
   Form1->Button54->Caption="Auto Run";
   Timer1->Enabled=false;
   Form1->RichEdit1->Lines->Add("Timer Stop!!!");
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button53Click(TObject *Sender)
{
   if(MyItemFocused<Form1->StringGrid1->RowCount)
    {
     MyItemFocused=Form1->StringGrid1->Row;
     Form1->RichEdit1->Lines->Add("MyItemFocused = " + IntToStr(MyItemFocused));
     }

//---------------------------------------
   if(MyItemFocused!=NULL)
    {
     if(MyItemFocused<Form1->StringGrid1->RowCount)
     {
      //--------------------------------

      //  MyItemFocused=SimulateOBC(MyItemFocused, Form1->StringGrid1->Cells[2][MyItemFocused]);
      if(OneStepInGrid (MyItemFocused))
      {
       if(Trim(Form1->StringGrid1->Cells[2][MyItemFocused+1])!="")  // !!!      - 
        {
         MyItemFocused++;    //     

 //     Form1->RichEdit1->Lines->Add("MyItemFocused = 0x" + IntToStr(MyItemFocused));


      if(MyItemFocused>4)
       Form1->StringGrid1->TopRow=MyItemFocused-4;

      //--------------------------------
      TGridRect myRect;
	    myRect.Left = 1;
      myRect.Top = MyItemFocused;
	    myRect.Right = Form1->StringGrid1->ColCount;
	    myRect.Bottom = MyItemFocused;
	    Form1->StringGrid1->Selection = myRect;
      //--------------------------------
         }
       else
        {
         Form1->RichEdit1->Lines->Add("    - " + IntToStr(MyItemFocused));
         ShowMessage(" !  -" + IntToStr(MyItemFocused));
         }

       }
       
      }
    }
  //---------------------------------------
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button61Click(TObject *Sender)
{
   Form1->Timer1->Enabled=false;
   Form1->RichEdit1->Lines->Add("Timer Stop!!!");
  //----------------------------------
  if(Form1->Button54->Caption=="Stop")
  {
   Form1->Button54->Caption="Auto Run";
   }
  //----------------------------------
  Form1->StringGrid1->TopRow=1;
  MyItemFocused = 1;

       //--------------------------------
      TGridRect myRect;
	    myRect.Left = 1;
      myRect.Top = MyItemFocused;
	    myRect.Right = Form1->StringGrid1->ColCount;
	    myRect.Bottom = MyItemFocused;
	    Form1->StringGrid1->Selection = myRect;
      //--------------------------------

//  bFindFirstErrorOBC=false;     //       
}
//---------------------------------------------------------------------------

void __fastcall TForm1::StringGrid1Click(TObject *Sender)
{
 MyClickOnGreed ();
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void MyClickOnGreed (void)
{
   Form1->Timer1->Enabled=false;

   if(MyItemFocused<Form1->StringGrid1->RowCount)
     {
      MyItemFocused=Form1->StringGrid1->Row;
      Form1->RichEdit1->Lines->Add("MyItemFocused = " + IntToStr(MyItemFocused));
      }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
    Timer1->Enabled=false;

   if(MyItemFocused!=NULL)
    {
     if(MyItemFocused<Form1->StringGrid1->RowCount)
     {

      //--------------------------------
      //   MyItemFocused=SimulateOBC(MyItemFocused, Form1->StringGrid1->Cells[2][MyItemFocused]);
      if(MyItemFocused>4)
       Form1->StringGrid1->TopRow=MyItemFocused-4;

      //--------------------------------
      TGridRect myRect;
	    myRect.Left = 1;
      myRect.Top = MyItemFocused;
	    myRect.Right = Form1->StringGrid1->ColCount;
	    myRect.Bottom = MyItemFocused;
	    Form1->StringGrid1->Selection = myRect;
      //--------------------------------
      OneStepInGrid (MyItemFocused);    //     
      MyItemFocused++;

  //    Form1->RichEdit1->Lines->Add("MyItemFocused = 0x" + IntToStr(MyItemFocused));
      }
    }
    if(Form1->Button54->Caption=="Stop")
     {
      Timer1->Interval = StrToInt(Form1->ComboBox47->Text);


      // !!!      - 
    if(MyItemFocused<=Form1->StringGrid1->RowCount)
     {

      if(  (Trim(Form1->StringGrid1->Cells[1][MyItemFocused])!="BP")    //   -  
         &&(Trim(Form1->StringGrid1->Cells[2][MyItemFocused])!=""))     //   - 
         //   
         Timer1->Enabled = true;
      else
       {
        if ((Trim(Form1->StringGrid1->Cells[1][MyItemFocused]))=="BP")
         {
          //--------------------------------
          TGridRect myRect;
	        myRect.Left = 1;
          myRect.Top = MyItemFocused;
	        myRect.Right = Form1->StringGrid1->ColCount;
	        myRect.Bottom = MyItemFocused;
	        Form1->StringGrid1->Selection = myRect;
          //--------------------------------
          Form1->RichEdit1->Lines->Add("Cycle Breaked at " + IntToStr(MyItemFocused));
          Form1->Button54->Caption="Auto Run";
          }
        if (Trim(Form1->StringGrid1->Cells[2][MyItemFocused])=="")
         {
          Form1->RichEdit1->Lines->Add("    - " + IntToStr(MyItemFocused-1));
          Form1->Button54->Caption="Auto Run";
          ShowMessage("    - " + IntToStr(MyItemFocused-1));
          }
        }
     }
    }
}
//---------------------------------------------------------------------------
  

//---------------------------------------------------------------------------

void __fastcall TForm1::Button18Click(TObject *Sender)
{
 LoadMyGrid();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button19Click(TObject *Sender)
{
   // Save to file by SaveDialog
   SaveDialog1->Title = "Save Table to File:";
   if (SaveDialog1->Execute())
   { // writing Table
     String strFileName = SaveDialog1->FileName;
     SaveStringGrid (Form1->StringGrid1, strFileName);
   }  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::StringGrid1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   StringGrid1->MouseToCell(X, Y, Column, Row);
   MyItemFocused = Row    /*+ (StringGrid1->TopRow)*/;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button20Click(TObject *Sender)
{
 StringGrid1->RowCount= StringGrid1->RowCount + 5;
 Form1->Update();  // Form1->StringGrid1->Repaint();
   for (int J = 1; J < StringGrid1->RowCount; J++)
    StringGrid1->Cells[0][J]=IntToStr(J); //

}
//---------------------------------------------------------------------------
void __fastcall TForm1::StringGrid1DblClick(TObject *Sender)
{
  if(RadioButton3->Checked==true)
   {
   //*********************************************************************************************
   //   ,       
   //     !!!
   //*********************************************************************************************
    StringGrid1->Cells[Column][Row] = ComboBox4->Text;
    if(Form1->ComboBox4->Text != Form1->ComboBox4->Items->Strings[0])
      {
       Form1->ComboBox4->Items->Insert(0, Form1->ComboBox4->Text);

       if(Form1->ComboBox4->Items->Count>10)
        Form1->ComboBox4->Items->Delete(10);
       }
    }
  else
   ComboBox4->Text = StringGrid1->Cells[Column][Row];
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBox2Change(TObject *Sender)
{
 if(ComboBox2->Text == "TapIrScan")
  {
   Form1->ComboBox4->Items->Clear();
   ComboBox4->Text = "TapIrScan";
   Form1->ComboBox4->Items->Add("TapIrScan");
   Form1->ComboBox4->Items->Add("Addr=USER1");
   Form1->ComboBox4->Items->Add("Addr=USER2");
   Form1->ComboBox4->Items->Add("Addr=Bypass");
   Form1->ComboBox4->Items->Add("Addr=ID");
   Form1->ComboBox4->Items->Add("Addr=USERCODE");
   }
 else if (ComboBox2->Text == "TapDrScan")
  {
   Form1->ComboBox4->Items->Clear();
   ComboBox4->Text = "TapDrScan";
   Form1->ComboBox4->Items->Add("TapDrScan");
   Form1->ComboBox4->Items->Add("TapDrData");
   Form1->ComboBox4->Items->Add("DataScanLength");
   }
 else if (ComboBox2->Text == "TapEndState")
  {
   Form1->ComboBox4->Items->Clear();
   Form1->ComboBox4->Text = "Run-Test/Idle";
   Form1->ComboBox4->Items->Add("Run-Test/Idle");
   Form1->ComboBox4->Items->Add("Test-Logic-Reset");
   Form1->ComboBox4->Items->Add("Shift-IR");
   Form1->ComboBox4->Items->Add("Shift-DR");
   Form1->ComboBox4->Items->Add("Update-DR");
   }

 else if (ComboBox2->Text == "Comment")
  {
   Form1->ComboBox4->Items->Clear();
   Form1->ComboBox4->Text = "Enter Comment";
   Form1->ComboBox4->Items->Add("Go to Run-Test/Idle");
   Form1->ComboBox4->Items->Add("Go to Test-Logic-Reset");
   Form1->ComboBox4->Items->Add("Make Shift-IR");
   Form1->ComboBox4->Items->Add("Make Shift-DR");
   Form1->ComboBox4->Items->Add("Set Ir Addr");
   Form1->ComboBox4->Items->Add("Set Dr Addr");
   Form1->ComboBox4->Items->Add("Set USER1 Addr");
   Form1->ComboBox4->Items->Add("Set USER2 Addr");
   }
  else if (ComboBox2->Text == "Get ID")
  {
   Form1->ComboBox4->Items->Clear();
   Form1->ComboBox4->Text = "Get ID";
   }

/*
 else
  {

   } */

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
   // Save to file by SaveDialog
   SaveDialog2->Title = "Save Log to File:";
   if (SaveDialog2->Execute())
   { // writing to file
     String strFileName = SaveDialog2->FileName;

    String strFullFileName;
   if(strFileName.Pos('.') == NULL)
     strFullFileName = strFileName + ".log";
   else
     strFullFileName = strFileName.SubString(1, (strFileName.Pos('.'))-1) + ".log";

     Form1->RichEdit1->Lines->SaveToFile(strFullFileName);
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{
 //
  for (int i=0;i<(BtnsDone);i++)     //Btns -       
    {
     if(psg[i]==Sender)
      {
       Edit55->Text = IntToStr(i);     //  
       Label41->Caption = " ";
       break;
       }
     }
}
//---------------------------------------------------------------------------

